//+------------------------------------------- 
//| BatteryInfo Widget
//+------------------------------------------- 
//| $LastChangedDate$
//+-------------------------------------------
//| Info:
//| Copyright (c) 2005 Ben Barnett
//| widgets@menial.co.uk
//+-------------------------------------------


/***
* Loads Preferences
*
* PREFS:
* lastUpdate		Unix timestamp of last update check
* updateInterval	How often the widget should update in milliseconds
* showPercentage	Whether or not to show the LCD badge
* showTime			Whether or not to show the time remaining
***/
function getPrefs() {
	if (debug) alert('DEBUG: Loading preferences');
	if (window.widget)
		{
		lastUpdate = widget.preferenceForKey("lastUpdate");
		if (isNaN(lastUpdate))
			{
			lastUpdate = 0;
			}
			
		updateInterval = widget.preferenceForKey("updateInterval");
		if (isNaN(updateInterval))
			{
			updateInterval = 10000;
			}
		
		
		showPercentage = widget.preferenceForKey("showPercentage");
		if (showPercentage == true)
			{
			document.getElementById('badge').style.display = 'block';
			}
		else
			{
			document.getElementById('badge').style.display = 'none';
			}
		
			
		showTime = widget.preferenceForKey("showTime");
		if (showTime == true)
			{
			document.getElementById('info').style.display = 'block';
			document.getElementById("flip").style.background = 'url(file:///System/Library/WidgetResources/ibutton/black_i.png)';
				
			if (document.getElementById('back').style.display != 'block')
				{	
				resizeTo(128, 135);
				}
			}
		else
			{
			document.getElementById('info').style.display = 'none';
			document.getElementById("flip").style.background = 'url(file:///System/Library/WidgetResources/ibutton/white_i.png)';
				
			if (document.getElementById('back').style.display != 'block')
				{	
				resizeTo(128, 128);
				}
			}
		}
}


/***
* Saves preferences
*
* Called whenever an option changes.
* Saves to plist, then resets timer
***/
function setPrefs(elem)
{
if (debug) alert('DEBUG: Setting preferences for: '+elem);	
if(window.widget)
	{

	switch (elem)
		{
		case 'updateInterval':
		udI = document.getElementById(elem);
		updateInterval = udI.options[udI.selectedIndex].value;
		widget.setPreferenceForKey(updateInterval, "updateInterval");
		break;
		
		case 'displayPercentage':
		showPercentage = document.getElementById(elem).checked;
		widget.setPreferenceForKey(showPercentage, "showPercentage");
		break;
		
		case 'displayTime':
		showTime = document.getElementById(elem).checked;
		widget.setPreferenceForKey(showTime, "showTime");
		break;
		}
		
	getPrefs();
	showStatus();	
	}


}


/***
* Updates back of widget
*
* Sets the various controls to display the 
* current preference. Called on loading.
***/
function updatePrefs() {
	if (debug) alert('DEBUG: Updating display of reverse-side prefs');

	var selectPref = document.getElementById('prefs').updateInterval;
	
	with (selectPref) {
		selectedIndex = 0; 
		for (var i=0; i<options.length; i++) {
			if (options[i].value == updateInterval)
				selectedIndex = i;
		}
	}

	
	
	if (showPercentage == true)
		{
		document.getElementById('displayPercentage').checked = true;
		}
	
	if (showTime == true)
		{
		document.getElementById('displayTime').checked = true;
		}
	
	if (showTime == false)
		{
		document.getElementById("flip").style.background = 'url(file:///System/Library/WidgetResources/ibutton/white_i.png)';
		}
}