//+------------------------------------------- 
//| BatteryInfo Widget
//+------------------------------------------- 
//| $LastChangedDate: 2006-04-29 12:46:26 +0100 (Sat, 29 Apr 2006) $
//+-------------------------------------------
//| Info:
//| Copyright (c) 2005 Ben Barnett
//| widgets@menial.co.uk
//+-------------------------------------------
//+-------------------------------------------
//| Updating Functions
//| updateCheck: 		Checks for new version online
//| checkLastUpdate:	Checks to see if we need to call updateCheck (No more than once per day)
//| hideUpdatePanel:	Hides the "update available" dialog
//+-------------------------------------------



/***
* Checks for latest version of widget
*
* Connects to update.menial.co.uk and see what the latest version is. If the
* version number from the site doesn't match this one, a link is shown.
***/
function updateCheck() 
	{
	if (debug) alert('DEBUG: Checking for new version');
	
	var latestVersion = getKeyValue("http://update.menial.co.uk/widgets/batteryinfo/?version="+widgetVersion, "CFBundleVersion");
	
	if(latestVersion != widgetVersion)
		{
		document.getElementById('noticetext').innerText = getLocalizedString('updateavailable');
		document.getElementById('notice').style.display = "block";
		}
	else
		{
		// No action
		}
	dateNow = new Date();
	dateNow = Math.round(dateNow.getTime() / 1000);
	widget.setPreferenceForKey(dateNow, 'lastUpdate');
	}


function checkLastUpdate()
	{
	if (debug) alert('DEBUG: Checking last update time');
	dateNow = new Date();
	dateNow = Math.round(dateNow.getTime() / 1000);
	updateCheck();
	//if ( (dateNow - lastUpdate) >= 86400 )
//		{
//		updateCheck();
//		}
	}