/*
	This source code is property of e dot studios. Any modifications or use of this code in other applications or derived works, in parts or in whole, is prohibited without the specific permission of the author. 
	e dot studios cannot be held responsible for any damage that may be caused by the use or misuse of this product.
	
	For more information contact e dot studios (contact@edot-studios.com)
*/

var gInfoButton;
var gDoneButton;
var gResetButton;

var gAnimator;

var gCounter;
var gToFront = false;

function init() {
	if (window.widget) {
		widget.onshow = onshow;
  		widget.onhide = onhide;
  		widget.onremove = onremove;
  		
  		widget.setCloseBoxOffset(5,5);
  		
  		gInfoButton = new AppleInfoButton(document.getElementById("infoButton"), document.getElementById("front"), "white", "white", showBack);
  		gDoneButton = new AppleGlassButton(document.getElementById("doneButton"), "Done", hideBack);
  		gResetButton = new AppleGlassButton(document.getElementById("resetButton"), "Reset", resetCounter);
  		
  		var s = widget.preferenceForKey("saveCounter");
  		var c = widget.preferenceForKey("counter");
  		
  		gCounter = (c && s == "1") ? c : 0;
	}
}

function onshow() {
	var checkBox = document.getElementById("incButton");
	var setting = widget.preferenceForKey("saveCounter");
	checkBox.checked = setting ? setting : 0;
	
	updateCounter();
}

function onhide() {
	savePrefs();
}

function onremove() {
	onhide();
}

/* Backside */

function willShowBack() {
	gToFront = false;
	gAnimator = new AppleAnimator(250, 13, 128, 256, animationHandler);
	gAnimator.start();
}

function willHideBack() {
	gToFront = true;
	gAnimator = new AppleAnimator(250, 13, 256, 128, animationHandler);
	gAnimator.start();
}

function showBack() {
	var front = document.getElementById("front");
    var back = document.getElementById("back");
    
    window.resizeTo(256, 135);
    
    if (window.widget)
        widget.prepareForTransition("ToBack");

    front.style.display="none";
    back.style.display="block";
	
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);
}

function hideBack() {
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget)
        widget.prepareForTransition("ToFront");

	window.resizeTo(128, 135);

    back.style.display="none";
    front.style.display="block";
		
    if (window.widget)
 		setTimeout ('widget.performTransition();', 0); 
}


function animationHandler(animation, current, start, finish) {
	//window.resizeBy(current, 0);
	
	//alert(current+" "+start+" "+finish);
	
	if (finish) {
		if (gToFront) hideBack();
		else showBack();
		
		gAnimator.stop();
		delete gAnimator;
	}
}

/* Functions */

function resetCounter() {
	gCounter = 0;
	updateCounter();
}

function updateCounter() {
	var counterTextDiv = document.getElementById("counterText");
	
	gCounter++;
		
	counterTextDiv.innerText = ""+gCounter;
}

function savePrefs() {
	var checkBox = document.getElementById("incButton");
	var setting = checkBox.checked;
	
	widget.setPreferenceForKey(setting, "saveCounter");
	widget.setPreferenceForKey(gCounter, "counter");
}