//
// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
//
function load()
{
    setupParts();
	if (widget.preferenceForKey("confirmBeforeQuit") == "No") confirmBeforeQuit = false; //true by default
	else confirmBeforeQuit = true;
	document.getElementById("confirm_quit_checkbox").checked = confirmBeforeQuit;
	
	if (widget.preferenceForKey("autoUpdateRAM") == "Yes") autoUpdateRAM = true; //false by default
	else autoUpdateRAM = false;
	document.getElementById("autoUpdateRAM_checkbox").checked = autoUpdateRAM;
	
	updateAmountOfRAM();
	if (autoUpdateRAM) RAMUpdater.start();
}

//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
 	if (autoUpdateRAM) RAMUpdater.stop();
}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
	if (autoUpdateRAM) RAMUpdater.stop();
}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
	if (autoUpdateRAM) RAMUpdater.start();
}

//
// Function: sync()
// Called when the widget has been synchronized with .Mac
//
function sync()
{
}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

	window.resizeTo(225,145);

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    back.style.display = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

	window.resizeTo(110,100);

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}


//****** Amount of RAM
//Object use to start and stop the timer who update the display of the amount of RAM used by dashboard.
var RAMUpdater = {
	interval: 60000, //One minute
	timer:null,
	start: function () {
		if (this.timer != null) this.stop();
		this.timer = setInterval("updateAmountOfRAM(null)", this.interval);
	}, 
	stop: function () {
		clearInterval(this.timer);
		this.timer = null;
	}
};

//Display the amount of ram used.
function updateAmountOfRAM(event)
{
	var commande = widget.system("/usr/bin/top -l1 -p '^bbbbbbbbbbbbbb ^jjjjjjjjjjj' | /usr/bin/grep 'DashboardClient'", null);
	var total = 0;
	var lines = commande.outputString.split("\n");
	for (i = 0 ; i < lines.length ; i++) {
		val = parseInt(lines[i].replace(new RegExp("[^0-9]", "g"), ""));
		if (!isNaN(val)) total += val;
	}
	var prefix = "";
	if (total/1024 > 1) {
		total /= 1024;
		prefix = "k";
	}
	if (total/1024 > 1) {
		total /= 1024;
		prefix = "M";
	}
	total = Math.ceil(total);
		
	document.getElementById("amounOfRAM").innerText = total+prefix+getLocalizedString("octet");
}


//****** Stop dashboard functions
//Called to stop dashboard, show a confirm sheet if needed or call killall_dock
function stop_dashboard(event)
{
	if (confirmBeforeQuit) {
		quit_sheet = document.getElementById("quit_sheet");
		if (quit_sheet.style.opacity == 0.0) showQuitSheet(quit_sheet);
	} else {
		killall_dock();
	}
}

//Show/hide dasaboard
function showQuitSheet(quit_sheet) 
{
	handler = function(animation, current, start, finish) {
		quit_sheet.style.opacity = current;
		quit_sheet.style.top = 8+current*34+"px";
	};
	new AppleAnimator(500, 13, 0.0, 1.0, handler).start();
}
function hideQuitSheet(quit_sheet) 
{
	handler = function(animation, current, start, finish) {
		quit_sheet.style.opacity = 1.0-current;
		quit_sheet.style.top = 42-(current)*42+"px";
	};
	new AppleAnimator(500, 13, 0.0, 1.0, handler).start();
}


function cancel_stop_dashboard(event) 
{
	hideQuitSheet(document.getElementById("quit_sheet"));
}

function confirm_stop_dashboard(event) 
{

	killall_dock();
}

function killall_dock()
{
	widget.system("/usr/bin/killall Dock",null)
}


//****** Preferences functions
function update_confirmBeforeQuit(event)
{
	if (document.getElementById("confirm_quit_checkbox").checked) {
		confirmBeforeQuit = true; 
		widget.setPreferenceForKey("Yes", "confirmBeforeQuit");
	} else {
		confirmBeforeQuit = false; 
		widget.setPreferenceForKey("No", "confirmBeforeQuit");
	}
}


function update_autoUpdateRAM(event)
{
	if (document.getElementById("autoUpdateRAM_checkbox").checked) {
		autoUpdateRAM = true;
		widget.setPreferenceForKey("Yes", "autoUpdateRAM");
		RAMUpdater.start();
	} else {
		autoUpdateRAM = false;
		widget.setPreferenceForKey("No", "autoUpdateRAM");
		RAMUpdater.stop();
	}
}

//****** Other functions
//open my website in the default browser
function openMyWebsite(event)
{
	widget.openURL("http://elaum.free.fr/index.php?page=Logiciels/Dashquit");
}