/********************************
**  Writen by Steven Chaitoff  **
********************************/

var screensaverDesktop = null;	//async. system command
var isClocking = false;	//makes sure runCPUDaemon isn't called more than once
var isStartup = true;	//one-time use bool makes sure screensaver doesn't start on load

widget.onshow = runCPUDaemon;
widget.onhide = stopCPUDaemon;
widget.onremove = killScreenSaver;



function setup()
{
	getScreensaverList();

	var checkbox = document.getElementById('autoloads');
	if (widget.preferenceForKey("AUTOLOADS")) {
		checkbox.checked = true;
		startStop();
	}
	else {
		checkbox.checked = false;
	}

	return 0;
}



function startStop(i)
{
	if (isStartup)	isStartup = false;
	
	if ((screensaverDesktop != null) || i)
	{
		stopCPUDaemon();
		if (screensaverDesktop)	screensaverDesktop.cancel();
		stopScreensaver();
		document.getElementById('button').src = 'Images/Start.png';
		document.getElementById('controls').title = 'Run desktop screensaver';
		document.getElementById('controls_text').innerText = 'Run screensaver';
		document.getElementById('cpu').innerText = '';
	}
	else
	{
		document.getElementById('button').src = 'Images/Stop.png';
		document.getElementById('controls').title = 'Stop desktop screensaver';
		document.getElementById('controls_text').innerText = 'Stop screensaver';
		runScreensaver();
		runCPUDaemon();
	}
}



function formatEscapes(t)
{
	s = t.replace(/\'/g, "\\\'");
	s = s.replace(/\;/g, "\\\;");
	s = s.replace(/,/g, "\\\,");
	return s;	//"
}


var pid, exec = "/System/Library/Frameworks/ScreenSaver.framework/Resources/ScreenSaverEngine.app/Contents/MacOS/ScreenSaverEngine"
function runScreensaver()
{
	var text = document.getElementById('screensavername_text').innerText;
	text = formatEscapes(text);
	
	screensaverDesktop = widget.system(exec
		+" -module " + text.replace(/\s/g, '\\\ ')
		+" -background", stopScreensaver);

	pid = getProcessId();
}



function stopScreensaver()
{
	screensaverDesktop = null;
}



function killScreenSaver()
{
	widget.system('killall ScreenSaverEngine;', null);
}



function getScreensaverList()
{
	var saverStr = "/Library/Screen\\\ Savers -regex '.*\.(qtz|saver|slidesaver|slideSaver)'";
	var savername = widget.preferenceForKey("SAVERNAME") || "RSS Visualizer";
	var list = document.getElementById('screensaverlist');
	var index = new RegExp(savername, '');

	var out1, out2, out3;
	var sys = [ ], usr = [ ], lib = [ ];

	out1 = widget.system("find -E /System"+saverStr+";", null).outputString;
	if (out1)	{	sys = out1.split('\n');	sys.pop();	}
	out2 = widget.system("find -E ~/"+saverStr+";", null).outputString;
	if (out2)	{	usr = out2.split('\n');	usr.pop();	}
	out3 = widget.system("find -E /"+saverStr+";", null).outputString;
	if (out3)	{	lib = out3.split('\n');	lib.pop();	}

	var names = sys.concat(usr, lib, "/Computer Name.", "/Pictures Folder.");

	for (var i=0, j=names.length; i<j; i++) {
		var id = names[i].substring(names[i].lastIndexOf("/")+1, names[i].lastIndexOf("."));
		list.options[i] = new Option(id, id, false, index.test(id));
	}
	setNewScreensaver(list);
}



function setNewScreensaver(slct)
{
	var sname = slct.options[slct.selectedIndex].text;
	document.getElementById('screensavername_text').innerText = sname;
	widget.setPreferenceForKey(sname, "SAVERNAME");
	
	if (screensaverDesktop != null)	//if currently playing, restart with new choice
	{
		if (screensaverDesktop)	screensaverDesktop.cancel();
		stopScreensaver();
		runScreensaver();	
	}
}



var cpudaemon;
function getCPUPercentage()
{
	var cpu = widget.system("ps -cx -o %cpu,command | grep ScreenSaverEngine", null).outputString;
	document.getElementById('cpu').innerHTML = parseInt(cpu.substring(1,6)) + "%<br />CPU";
}



function runCPUDaemon()
{
	if (isStartup)
		return 0;
	if (isClocking)	//if cpu clock already started
		return 0;
	if (!isClocking && !screensaverDesktop)	//if idling
	{
		startStop(1);
		return 0;
	}

	isClocking = true;
	cpudaemon = setInterval("getCPUPercentage()", 1000);
}



function stopCPUDaemon()
{
	if (cpudaemon)
	{
		clearInterval(cpudaemon);
		isClocking = false;
	}
}



function getProcessId()
{
	return widget.system("ps -cx -o pid,command | grep ScreenSaverEngine", null).outputString;
}




/*** Preferences ***/

function setAutomaticallyLoads(checkbox) {
	if (!checkbox) {
		checkbox = document.getElementById('autoloads');
		checkbox.checked = checkbox.checked ? false : true;
	}
	widget.setPreferenceForKey(checkbox.checked ? 1 : 0, "AUTOLOADS");
}


