
// Timers
var theTimer = {step:3600000};

// Button state
var buttonHighlighted = false;

// Dusting state
var dustingOn = false;
var numberOfDaysFilesKept;

// Animation faders
var onImageFader = null;

// Event handlers
function toggleDusting() 
{
	dustingOn = !dustingOn;
	updateViews();
}

function highlightButton() 
{
	buttonHighlighted = true;
	displayButton();
}

function unhighlightButton() 
{
	buttonHighlighted = false;
	displayButton();
}

function displayButton() {
	document.getElementById("on-button").style.opacity = 0;
	document.getElementById("off-button").style.opacity = 0;
	document.getElementById("highlighted-on-button").style.opacity = 0;
	document.getElementById("highlighted-off-button").style.opacity = 0;
	var buttonToDisplay;
	if ( buttonHighlighted ) 
		buttonToDisplay = ( dustingOn ? "highlighted-on-button" : "highlighted-off-button" );
	else 
		buttonToDisplay = ( dustingOn ? "on-button" : "off-button" );
	document.getElementById(buttonToDisplay).style.opacity = 1;
}

function changeNumberOfDaysFilesKept() 
{
	var textField = document.getElementById("numberOfDaysFilesKeptField");
	var newVal = parseInt(textField.value);
	if ( !isNaN(newVal) && newVal > 0 ) numberOfDaysFilesKept = newVal; 
	textField.value = numberOfDaysFilesKept; // Set field to valid integer value
}	

// Other functions
function updateViews() {
	displayButton();
	if (dustingOn) { 
		onImageFader.fadeIn();
	}
	else {	
		onImageFader.fadeOut();
	}
}

function startDustingTimer() 
{
	if ( !theTimer.id ) theTimer.id = setInterval("dustDesktop()", theTimer.step);
}

function dustDesktop() {
	if ( dustingOn ) {
		var findCommand = "/usr/bin/find ~/Desktop -fstype local -maxdepth 1 -ctime +" + numberOfDaysFilesKept + " -exec mv -- {} ~/.Trash \\; >/dev/null 2>&1";
		widget.system(findCommand, null);
	}
}

// Standard widget functions
function load()
{
	// Fader
	document.getElementById("front-on-image").style.opacity = 0;
	onImageFader = new Fader(document.getElementById("front-on-image"), null, 750, 0.0, 1.0);
	
	// Preferences
	numberOfDaysFilesKept = widget.preferenceForKey("numberOfDaysFilesKept");
	if ( !numberOfDaysFilesKept ) numberOfDaysFilesKept = 7;
	document.getElementById("numberOfDaysFilesKeptField").value = numberOfDaysFilesKept;
	
	dustingOn = widget.preferenceForKey("dustingOn");
	if ( null == dustingOn ) dustingOn = false;
	
	// Update views
	buttonHighlighted = false;
	updateViews();
	
	// Timers
	startDustingTimer();
}

function remove()
{
	clearInterval(theTimer.id);
	theTimer.id = 0;
	widget.setPreferenceForKey(null, "numberOfDaysFilesKept");
	widget.setPreferenceForKey(null, "dustingOn");
}

function hide()
{
	widget.setPreferenceForKey(numberOfDaysFilesKept, "numberOfDaysFilesKept");
	widget.setPreferenceForKey(dustingOn, "dustingOn");
}

function show()
{
	startDustingTimer();
}

function showBack(event)
{
	// your widget needs to show the back

	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToBack");

	front.style.display="none";
	back.style.display="block";
	
	if (window.widget)
		setTimeout('widget.performTransition();', 0);
}

function showFront(event)
{
	// your widget needs to show the front

	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToFront");

	front.style.display="block";
	back.style.display="none";
	
	if (window.widget)
		setTimeout('widget.performTransition();', 0);
}

if (window.widget)
{
	widget.onremove = remove;
	widget.onhide = hide;
	widget.onshow = show;
}
