
var gInfoButton, gDoneButton;

// If we're running in Dashboard, set the onshow handler
// to check the server for a new message each time the
// dashboard is activated
if (window.widget)
{
    widget.onshow = getTodaysText;
}

// Create the info and done buttons for flipping between widget sides
function setup()
{
    gInfoButton = new AppleInfoButton(document.getElementById("infoButton"),
				      document.getElementById("front"),
				      "black", "black", flipToBack);
    gDoneButton = new AppleGlassButton(document.getElementById("doneButton"),
				       "Done", flipToFront);
}

// Send an HTTP request to get the message from the server
function getTodaysText()
{
    httpRequest = new XMLHttpRequest();
    httpRequest.onreadystatechange = function() { requestComplete(httpRequest); }
    httpRequest.open("GET", "http://www.surfnetkids.com/message/message.php?src=jokes", true);
    httpRequest.send("");
}

// Process the results of the HTTP request. Either show the retrieved message
// or show an error.
function requestComplete(httpRequest)
{
    if(httpRequest.readyState == 4) {
	var info = document.getElementById("todaysJoke");

	if(httpRequest.status == 200) {
	    info.innerHTML = extractResponse(httpRequest.responseText);
	}
	else {
	    var errorMsg = "Could not connect to server. Check network connection and try again";
	    errorMsg = errorMsg + "<br><br>(" + httpRequest.status + ")";
	    info.innerHTML = errorMsg;
	}
    }
}

// The PHP script on the server returns a series of JavaScript document.writeln() calls
// to construct the HTML that makes up the wizard. However, for dashboard widgets,
// most of the content is available locally and we really only need the message text.
// The first part of this function extracts just the message HTML from the entire response.
//
// Furthermore, HTML anchors do not work as expected when displayed in a widget.
// The web page is loaded in the widget window instead of the desired behavior of showing
// in a browser window. This function converts <A HREF="..."> elements
// into <span onclick="widget.openURL('...');"> elements
//
// Finally, remove the backslash before any escaped characters
function extractResponse(text)
{
    var result = new String;
    var lines = text.split("\n");

    var text=lines[3].substring(18, lines[3].length-3);
    var address=text.replace(/.*<A HREF=\"([^\"]+)\".*/, "$1");
    var noAnchors=text.replace(/<A[^S]*STYLE=\"([^\"]+)\"[^>]*>([^<]*)<\/A>/g,
	"<span style=\"$1\" onclick=\"widget.openURL('" + address + "');\">$2</span>");
    var noEscapes=noAnchors.replace(/\\(.)/g, "$1");

    return noEscapes;
}

// Standard dashboard code to flip to the back side
function flipToBack()
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");
    
    if (window.widget) {
	widget.prepareForTransition("ToBack");
    }
    
    front.style.display="none";
    back.style.display="block";
    
    if (window.widget){
        setTimeout ('widget.performTransition();', 0);
    }
}

// Standard dashboard code to flip to the front side
function flipToFront()
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");
    
    if (window.widget) {
	widget.prepareForTransition("ToFront");
    }
    
    back.style.display="none";
    front.style.display="block";
    
    if (window.widget) {
        setTimeout ('widget.performTransition();', 0);
    }    
}