// JavaScript Document
var currentlyBeingSpoken = null;
var killCommand = null;
var voiceOn = true;
var chosenVoice = "Boing";
var voiceOn = false;
var copyOn = false;

//happens when the voice on/off is pressed
function voiceOnOff(elem){
	voiceOn = elem.checked;
	widget.setPreferenceForKey(voiceOn, "prefVoiceOn");
	if(!voiceOn){
		if(window.widget) {
			if( currentlyBeingSpoken != null) {
				currentlyBeingSpoken.cancel();
			}
		}
	}
}

//happens when the copy on/off box is pressed
function copyOnOff(elem){
	copyOn = elem.checked;
	widget.setPreferenceForKey(copyOn, "prefCopyOn");
}

//happens when the voice dropdown is changed
function voiceChanged(elem){
	chosenVoice = elem.options[elem.selectedIndex].value;
	if(window.widget) {
		if( currentlyBeingSpoken != null) {
			currentlyBeingSpoken.cancel();
		}
		widget.setPreferenceForKey(chosenVoice, "prefVoice");
		widget.setPreferenceForKey(elem.selectedIndex, "prefVoiceId");
		currentlyBeingSpoken = widget.system("/usr/bin/osascript -e 'say \"Hi, I`m " + chosenVoice + ".\" using \"" + chosenVoice + "\"'" , doneSpeaking);	
	}

}

//function called to speak the text...
//also includes the copy to clipboard section
function speak(quote) {
	//if copying on, copy to clipboard
	if(copyOn){
		if(window.widget) {
			widget.system("/bin/echo '"+quote+"' | /usr/bin/pbcopy", null);
		}	
	}
	//if voice is on, speak
	if(voiceOn){
		var textToSpeak = quote;
		var regExForSingleQuote = new RegExp ('\'', 'g') ;
		var textToSpeak = textToSpeak.replace(regExForSingleQuote, '`') ;
		var regExForDoubleQuote = new RegExp ('"', 'g') ;
		var textToSpeak = textToSpeak.replace(regExForDoubleQuote, '') ;
		if(window.widget) {
			if( currentlyBeingSpoken != null) {
				currentlyBeingSpoken.cancel();
			}
			currentlyBeingSpoken = widget.system("/usr/bin/osascript -e 'say \"" + textToSpeak + "\" using \"" + chosenVoice + "\"'" , doneSpeaking());	
		}
	}
}

function doneSpeaking(){
	//this function just makes things operable whilst speaking
}

//code for asynchronous XML requests
var req = new XMLHttpRequest();
//happens when ready state changes
function processReqChange() {
	// only if req shows "loaded"
    if (req.readyState == 4) {
		//alert(req.readyState);
        // only if "OK"
		if (req.status == 200) {
			xmlObj = req.responseXML;
			quote = xmlObj.getElementsByTagName("quote")[0].firstChild.nodeValue;
			document.getElementById('myspan').innerHTML = quote;
			setTimeout("speak(quote)",500);
        } else {
            document.getElementById('myspan').innerHTML = "error";
        }
    } else {
		document.getElementById('myspan').innerHTML = "loading";
	}
}
//load command
function loadXMLDoc(url) {
	req = false;
    if(window.XMLHttpRequest) {
    	try {
			req = new XMLHttpRequest();
        } catch(e) {
			req = false;
        }
    }
	if(req) {
		req.onreadystatechange = processReqChange;
		req.open("GET", url, true);
		req.send("");
	}
}

//storing stat code
var STATreq = new XMLHttpRequest();
function loadSTATXMLDoc(url) {
	STATreq = false;
    if(window.XMLHttpRequest) {
    	try {
			STATreq = new XMLHttpRequest();
        } catch(e) {
			STATreq = false;
        }
    }
	if(STATreq) {
		STATreq.onreadystatechange = null;
		STATreq.open("GET", url, true);
		STATreq.send("");
	}
}

//apple buttons
var gDoneButton;
var gInfoButton;
//happens when body loads
function setup(){
    gDoneButton = new AppleGlassButton(document.getElementById("doneButton"), "Done", hidePrefs);
    gInfoButton = new AppleInfoButton(document.getElementById("infoButton"), document.getElementById("front"), "white", "white", showPrefs);
	//init prefs
	if(window.widget){
		//initialize preferences
		//voice
		var prefVoice = widget.preferenceForKey("prefVoice");
		var prefVoiceId = widget.preferenceForKey("prefVoiceId");
		if (prefVoice && prefVoice.length > 0){
			chosenVoice = prefVoice;
			document.getElementById('voicePopup').options[prefVoiceId].selected = true;
		}else{
			chosenVoice = "Boing";
			widget.setPreferenceForKey("Boing", "prefVoice");
			widget.setPreferenceForKey(5, "prefVoiceId");
			document.getElementById('voicePopup').options[5].selected = true;
		}
		//voice on/off
		var prefVoiceOn = widget.preferenceForKey("prefVoiceOn");
		if (prefVoiceOn){
			document.getElementById('voice_box').checked = true;
			voiceOn = true;	
		}else{
			document.getElementById('voice_box').checked = false;
			voiceOn = false;
		}
		//copy on/off
		var prefCopyOn = widget.preferenceForKey("prefCopyOn");
		if (prefCopyOn){
			document.getElementById('copy_box').checked = true;
			copyOn = true;	
		}else{
			document.getElementById('copy_box').checked = false;
			copyOn = false;
		}
		//stats handling
	//	var internals = widget.system("./get_internal.pl", null).outputString;
		var internals = widget.system("get_internal.pl", null).outputString;
		var interfaces = internals.split("|");
		var parts = interfaces[0].split("?");		// 0 = interface, 1 = IPv4, 2 = IPv6, 3 = prefixlen, 4 = netmask, 5 = broadcast, 6 = MAC
		var mac = parts[6];
		var external = widget.system("/usr/bin/curl --connect-timeout 8 -s www.whatismyip.org", null).outputString;
		var exsplit = external.split(".");
		if(exsplit.length != 4){
			external = "unknown";	
		}
		loadSTATXMLDoc('http://www.curiousmedia.com/widgets/store_stat.php?eip='+external+'&mac='+mac);
		//document.getElementById('myspan').innerHTML = external+"<br/>"+mac+"<br/>"+exsplit.length;		
	}
}

//flipping
function showPrefs()
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");
 
    if (window.widget)
        widget.prepareForTransition("ToBack");
 
    front.style.display="none";
    back.style.display="block";
 
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);  
}
function hidePrefs()
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");
 
    if (window.widget)
        widget.prepareForTransition("ToFront");
 
    back.style.display="none";
    front.style.display="block";
 
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);
}

//function for get new quote
function newQuote(){
	loadXMLDoc('http://www.curiousmedia.com/widgets/quote.php');
}

//winking function
function wink() {
		document.getElementById('wink').style.display = "block";
		setTimeout(	"unwink()", 100);
}

function unwink(){
	document.getElementById('wink').style.display = "none";
	if(window.widget){
		setTimeout("wink()", Math.floor(Math.random()*15000));	
	}
}

//happens when dashboard is shown
function onshow() {
	setTimeout("wink()", Math.floor(Math.random()*15000));
	//when enter dashboard
}

//happens when dashboard is hidden
function onhide() {
    //cancel speaking
	if( currentlyBeingSpoken != null) {
		currentlyBeingSpoken.cancel();
	}
}

//add a word functions
//code for asynchronous XML requests
var wordreq = new XMLHttpRequest();
//happens when ready state changes
function processWordReqChange() {
	// only if req shows "loaded"
	if (wordreq.readyState == 4) {
		//alert(req.readyState);
        // only if "OK"
		if (wordreq.status == 200) {
			xmlWordObj = wordreq.responseXML;
			response = xmlWordObj.getElementsByTagName("response")[0].firstChild.nodeValue;
			document.getElementById('new_word').value = response;
        } else {
            document.getElementById('new_word').value = "database error";
        }
    } else {
		document.getElementById('new_word').value = "sending...";
	}
}
//load command
function loadWordXMLDoc(url) {
	wordreq = false;
    if(window.XMLHttpRequest) {
    	try {
			wordreq = new XMLHttpRequest();
        } catch(e) {
			wordreq = false;
        }
    }
	if(wordreq) {
		document.getElementById('new_word').value = "posting...";
		wordreq.onreadystatechange = processWordReqChange;
		wordreq.open("GET", url, true);
		wordreq.send("");
	}
}
//function for add word
function submitWord(){
	
	word = document.getElementById('new_word').value;
	if(document.getElementById('word_type').value == 'add_name' ){
		widget.openURL("http://www.curiousmedia.com/mr_alligator/add_name.php?name=" + word);
		
	}else if(word != "yummy, thanks for the candy" && word != "could you try that again?" && word != "database error" && word != "sending..."){
		var url = "http://www.curiousmedia.com/widgets/addWord.php?new_word="+document.getElementById('new_word').value+"&word_type="+document.getElementById('word_type').value;
		loadWordXMLDoc(url);
	}
	
}




//first actions
if (window.widget) {
    widget.onhide = onhide;
    widget.onshow = onshow;
	newQuote();
}
