// This file was generated by Dashcode from Apple Inc.
// You may edit this file to customize your Dashboard widget.

//
// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
//
function load()
{
    setupParts();
	loadSettings();
}

//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
    // Stop any timers to prevent CPU usage
    // Remove any preferences as needed
    // widget.setPreferenceForKey(null, createInstancePreferenceKey("your-key"));
}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
    // Stop any timers to prevent CPU usage
}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
    // Restart any timers that were stopped on hide
	update();
}

//
// Function: sync()
// Called when the widget has been synchronized with .Mac
//
function sync()
{
    // Retrieve any preference values that you need to be synchronized here
    // Use this for an instance key's value:
    // instancePreferenceValue = widget.preferenceForKey(null, createInstancePreferenceKey("your-key"));
    //
    // Or this for global key's value:
    // globalPreferenceValue = widget.preferenceForKey(null, "your-key");
}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    back.style.display = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

function saveData(event) {
	if (window.widget) {
        widget.setPreferenceForKey(document.getElementById('day').value, 'day');
        widget.setPreferenceForKey(document.getElementById('month').value, 'month');
        widget.setPreferenceForKey(document.getElementById('year').value, 'year');
        widget.setPreferenceForKey(document.getElementById('b_currency').value, 'currency');
        widget.setPreferenceForKey(document.getElementById('b_cost').value, 'cost');
        widget.setPreferenceForKey(document.getElementById('transparent').value, 'transparent');
    }
    update();
	showFront(event)
}

function update() {
    var today = new Date();
   
    var day = document.getElementById('day').value;
    var month = document.getElementById('month').value;
    var year = document.getElementById('year').value;
    
    var days = 0;
    if (day && year && month) {
       var start = new Date(year, month-1, day);
       days = (today.getTime() - start.getTime())/86400000;
       days = Math.round(days);
    }
	
	// Update the days
    document.getElementById('f_days').innerHTML = days + " " + localizedStrings['Days'];
	
	// Update the cost
	var cost =  document.getElementById('b_cost').value;
	if (cost != undefined && cost != 0) {
		document.getElementById('f_cost').innerHTML = document.getElementById('b_currency').value + Math.round(days * cost);
	} else {
		document.getElementById('f_cost').innerHTML = '';
	}
	
	// Update the transparency setting
	var transparent = document.getElementById('transparent').children[0].checked;
	if (transparent) {
		document.getElementById("background").style.display="none";
	} else {
		document.getElementById("background").style.display="block";
	}
}

function loadSettings() {
	if (window.widget) {
        var day = widget.preferenceForKey('day');
        var month = widget.preferenceForKey('month');
        var year = widget.preferenceForKey('year');
    }
    if (day == undefined || month == undefined || year == undefined) {
        var today = new Date();
        var day = today.getDate();
        var month = today.getMonth()+1;
        var year = today.getFullYear();
    }
    document.getElementById('day').value = day;
    document.getElementById('month').value = month;
    document.getElementById('year').value = year;
	
	var currency = widget.preferenceForKey('currency');
	var cost = widget.preferenceForKey('cost');
	if (currency == undefined) {
		currency = "$";
	}
	if (cost == undefined) {
		cost = "0";
	}
    document.getElementById('b_currency').value = currency;
    document.getElementById('b_cost').value = cost;
	
	var transparent = widget.preferenceForKey('transparent');
	if (transparent == undefined) {
		transparent = false;
	}
	document.getElementById('transparent').children[0].checked = transparent;
}

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}