// preferences
var pref_countDown_Key = "backCountDown";
var pref_shouldSleepDisplay_Key = "shouldSleepDisplayValue";
var pref_shouldScreenSaver_Key = "shouldScreenSaverValue";
var pref_shouldSuspend_Key = "shouldSleepValue";
var pref_shouldSuspend2Disk_Key = "shouldSleep2DiskValue";
var pref_shouldShutdown_Key = "shouldShutdownValue";
var pref_actionButtonBG_Key = "backColor";

var pref_countDown = null;
var pref_shouldSleepDisplay = null;
var pref_shouldScreenSaver = null;
var pref_shouldSuspend = null;
var pref_shouldSuspend2Disk = null;
var pref_shouldShutdown = null;
var pref_actionButtonBG = null;
var actionButtonBG = null; 

// dimesions of front and back
var frontDim = {width: 48, height: 48};
var backDim = {width: 210, height: 280};

var timer = null;
var timerInterval = 0.250;
var isTimerRunning = false;
var actionButtonAlternator = true;
var secondsToRun = -1;

function $(element) {
	return document.getElementById(element);
}

function getInstancePref(key) {
	return widget.preferenceForKey(widget.identifier + "-" + key);
}

function setInstancePref(value, key) {
	widget.setPreferenceForKey(value, widget.identifier + "-" + key);
}

function loadActionButtonBgImage(color) {
	var imgPath = "Images/actionButtonBG";
	var image = imgPath +"_" + color + ".png";
	
	var frontImg = $("frontImg");
	frontImg.src = image;
	alert("Loading front image: " + frontImg.src);
}

function resizeWidgetSide(side) {
	switch (side) {
		case "front":
			window.resizeTo( frontDim.width, frontDim.height );
			break;
		case "back":
			window.resizeTo( backDim.width, backDim.height );
			break;
	}
}

function initTime() {
	clearInterval(timer);
	timer = null;
	isTimerRunning = false;
	secondsToRun = -1;
}

function showBack(event)
{
	resizeWidgetSide("back");
    var front = $("front");
    var back = $("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    back.style.display = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

function showFront(event)
{
    var front = $("front");
    var back = $("back");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }
	resizeWidgetSide("back");
	
    front.style.display="block";
    back.style.display="none";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }


	// preferences
	// calculate Timer
	pref_countDown = $("backCountDown").value;
	alert("New pref for count down: " + pref_countDown);
	
	// actions
	pref_shouldSleepDisplay = $("shouldSleepDisplayValue").checked;
	alert("New pref for shouldSleepDisplay: " + pref_shouldSleepDisplay);
	pref_shouldScreenSaver = $("shouldScreenSaverValue").checked;
	alert("New pref shouldScreenSaver: " + pref_shouldScreenSaver);
	pref_shouldSuspend = $("shouldSleepValue").checked;
	alert("New pref for shouldSleepValue: " + pref_shouldSuspend);
	pref_shouldSuspend2Disk = $("shouldSleep2DiskValue").checked;
	alert("New pref for shouldSleep2DiskValue: " + pref_shouldSuspend2Disk);
	pref_shouldShutdown = $("shouldShutdownValue").checked;
	alert("New pref for shouldShutdownValue: " + pref_shouldShutdown);
		
	// color of button background
	pref_actionButtonBG = $(pref_actionButtonBG_Key).object.select.options.selectedIndex;
	actionButtonBG = $("backColor").object.getValue();
	alert("New color of front image: " + actionButtonBG);

	// hack: execute layout changes
	setTimeout( updateUI, 10 );
	
	savePref();
}

function updateUI(event) {
	alert("updateUI");
	loadActionButtonBgImage(actionButtonBG);
}

function goAction(event)
{
	if (!isTimerRunning) {
		var timeStrs = pref_countDown.split(':');
		secondsToRun = parseInt(timeStrs[0])*3600 + parseInt(timeStrs[1])*60 + parseInt(timeStrs[2]);
		isTimerRunning = true;
		timer = setInterval( timerCallback, timerInterval*1000 );
		alert("Timer started: " + secondsToRun);
	} else {
		initTime();
		loadActionButtonBgImage(actionButtonBG);
		alert("Timer canceled by user.");
	}
}

function timerCallback() {
	if ( secondsToRun > 0 ) {
		secondsToRun = secondsToRun - timerInterval;
		actionButtonAlternator ^= true;
		if (actionButtonAlternator) {
			loadActionButtonBgImage(actionButtonBG);
		} else {
			loadActionButtonBgImage("Grey");
		}
		alert("Will execute Off in " + secondsToRun + " sec.");
		return;
	} else {
		initTime();
		executeActions();
	}
}

function executeActions() {
	var cmdLine = "Off";
	if (pref_shouldSleepDisplay == true) {
		cmdLine = cmdLine + " sleepdisplay";
	}
	if (pref_shouldScreenSaver == true) {
		cmdLine = cmdLine + " screensaver";
	}
	if (pref_shouldSuspend == true) {
		cmdLine = cmdLine + " suspend";
	}
	if (pref_shouldSuspend2Disk == true) {
		cmdLine = cmdLine + " susp2disk";
	}
	if (pref_shouldShutdown == true) {
		cmdLine = cmdLine + " shutdown";
	}
	
	alert("Executing: "+cmdLine);
	widget.system(cmdLine);
}

function showWebsite(event)
{
	var websiteURL = "http://iv.cs.uni-bonn.de/pustina/";
	widget.openURL(websiteURL);
}

function load() {
    setupParts();
	loadPref();	
	loadActionButtonBgImage(actionButtonBG);
}

function show() {
}

function hide() {
}

function sync() {
}

function remove()
{
	// delete instance preferences
	var preferenceForKey = null;
	var preferenceValue = null;

	preferenceForKey = pref_countDown_Key;
	widget.setPreferenceForKey(preferenceValue, widget.identifier + "-" + preferenceForKey);

	preferenceForKey = pref_shouldSleepDisplay_Key;
	widget.setPreferenceForKey(preferenceValue, widget.identifier + "-" + preferenceForKey);
	
	preferenceForKey = pref_shouldScreenSaver_Key;
	widget.setPreferenceForKey(preferenceValue, widget.identifier + "-" + preferenceForKey);
	
	preferenceForKey = pref_shouldSuspend_Key;
	widget.setPreferenceForKey(preferenceValue, widget.identifier + "-" + preferenceForKey);

	preferenceForKey = pref_shouldSuspend2Disk_Key;
	widget.setPreferenceForKey(preferenceValue, widget.identifier + "-" + preferenceForKey);

	preferenceForKey = pref_shouldShutdown_Key;
	widget.setPreferenceForKey(preferenceValue, widget.identifier + "-" + preferenceForKey);

	preferenceForKey = pref_actionButtonBG_Key;
	widget.setPreferenceForKey(preferenceValue, widget.identifier + "-" + preferenceForKey);
}

function loadPref() {
	// set instance preferences
	var preferenceForKey = null;
	var preferenceValue = null;

	preferenceForKey = pref_countDown_Key;
	if  (widget.preferenceForKey(widget.identifier + "-" + preferenceForKey) != null) {
		pref_countDown = getInstancePref(preferenceForKey);
		$(preferenceForKey).value = pref_countDown;

		preferenceForKey = pref_shouldSleepDisplay_Key;
		pref_shouldSleepDisplay = getInstancePref(preferenceForKey);
		$(preferenceForKey).checked = pref_shouldSleepDisplay;
		
		preferenceForKey = pref_shouldScreenSaver_Key;
		pref_shouldScreenSaver = getInstancePref(preferenceForKey);
		$(preferenceForKey).checked = pref_shouldScreenSaver;
		
		preferenceForKey = pref_shouldSuspend_Key;
		pref_shouldSuspend = getInstancePref(preferenceForKey);
		$(preferenceForKey).checked = pref_shouldSuspend;

		preferenceForKey = pref_shouldSuspend2Disk_Key;
		pref_shouldSuspend2Disk = getInstancePref(preferenceForKey);
		$(preferenceForKey).checked = pref_shouldSuspend2Disk;

		preferenceForKey = pref_shouldShutdown_Key;
		pref_shouldShutdown = getInstancePref(preferenceForKey);
		$(preferenceForKey).checked = pref_shouldShutdown;

		preferenceForKey = pref_actionButtonBG_Key;
		pref_actionButtonBG = getInstancePref(preferenceForKey);
	} else {
		pref_countDown = "00:00:05";
		pref_shouldSleepDisplay = true;
		pref_shouldScreenSaver = false;
		pref_shouldSuspend = false;
		pref_shouldSuspend2Disk = false;
		pref_shouldShutdown = false;
		pref_actionButtonBG = 0;
	}
	var v = 	$(pref_actionButtonBG_Key).object;
	$(pref_actionButtonBG_Key).object.setSelectedIndex(pref_actionButtonBG);
	actionButtonBG = $(pref_actionButtonBG_Key).object.getValue();
}

function savePref() {
	// set instance preferences
	var preferenceForKey = null;
	var preferenceValue = null;

	preferenceForKey = pref_countDown_Key;
	preferenceValue = pref_countDown;
	setInstancePref(preferenceValue, preferenceForKey);

	preferenceForKey = pref_shouldSleepDisplay_Key;
	preferenceValue = pref_shouldSleepDisplay;
	setInstancePref(preferenceValue, preferenceForKey);
	
	preferenceForKey = pref_shouldScreenSaver_Key;
	preferenceValue = pref_shouldScreenSaver;
	setInstancePref(preferenceValue, preferenceForKey);

	preferenceForKey = pref_shouldSuspend_Key;
	preferenceValue = pref_shouldSuspend;
	setInstancePref(preferenceValue, preferenceForKey);
	
	preferenceForKey = pref_shouldSuspend2Disk_Key;
	preferenceValue = pref_shouldSuspend2Disk;
	setInstancePref(preferenceValue, preferenceForKey);
	
	preferenceForKey = pref_shouldShutdown_Key;
	preferenceValue = pref_shouldShutdown;
	setInstancePref(preferenceValue, preferenceForKey);

	preferenceForKey = pref_actionButtonBG_Key;
	preferenceValue = pref_actionButtonBG;
	setInstancePref(preferenceValue, preferenceForKey);
}

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}



