var sleepOption = true;

var instaSleep = true;
var method = 1;

var fader = null;

var timer = 0;
var timeout = null;

var timeFade = null;

var popupVis = false;

//
// Called by HTML body element's onload event when the widget is ready to start
//
function load()
{
    // hide the popup
    var ops = document.getElementById("popout");
    ops.style.opacity = 0.0;
    
    // load the instaSleep preference
    if(widget.preferenceForKey("instaSleep") != undefined)
    {
        if(widget.preferenceForKey("instaSleep") == "NO")
            instaSleep = false;
    }
    
    // load the method preference
    if(widget.preferenceForKey("method") != undefined)
        method = parseInt(widget.preferenceForKey("method"));

    // disable the sleep lock if we are not in Snow Leopard
    if(!isSnow())
    {
        // hide elements
        var lTm = document.getElementById("l_timer");
        var bTm = document.getElementById("b_timer");
        var fTm = document.getElementById("f_timer");
        var mTm = document.getElementById("m_timer");
        var tTm = document.getElementById("t_timer");
        lTm.style.display = "none";
        bTm.style.display = "none";
        fTm.style.display = "none";
        mTm.style.display = "none";
        tTm.style.display = "none";
        // move and resize elements
        var ch4 = document.getElementById("ch4");
        var pop = document.getElementById("popout");
        ch4.style.top = "70px";
        pop.style.height = "110px";
    }

    // update the sleep timer display element
    var val = getSleepTimer();
    var tmr = document.getElementById("m_timer");
    tmr.value = "" + val;
    
    // update the option display elements
    updateInstaSleep();
    updateMethod();
}

//
// Get the sleep timer's value
//
function getSleepTimer()
{
    
    // get the sleep delay
    var val = -1;
    var msg = widget.system("/usr/bin/defaults read "
        + "com.apple.screensaver askForPassword", null).outputString;
    if(msg == 1)
    {
        var msg = widget.system("/usr/bin/defaults read "
            + "com.apple.screensaver askForPasswordDelay", null).outputString;
        var val2 = parseInt(msg);
        if(val2 >= 0)
            val = Math.floor(val2 / 60);
    }
    
    return val;
}

//
//
//
function isSnow()
{
    var msg = widget.system("/usr/bin/sw_vers -productVersion", null).outputString;
    var vers = msg.substring(4, 0);
    
    if(vers == "10.6")
        return true;

    return false;
}

//
// Called to update the UI elements when the sleep method changes
//
function updateInstaSleep()
{
    var sBtn = document.getElementById("m_sleep");
    var iSleep = document.getElementById("sleeper");
    
    if(instaSleep == true)
    {
        sBtn.className = "m_sel";
        iSleep.style.display = "block";
    }
    else
    {
        sBtn.className = "m_dis";
        iSleep.style.display = "none";
    }
}

//
// Called to update the UI elements when the locking method changes
//
function updateMethod()
{
    var mLogin = document.getElementById("m_login");
    var mSleep = document.getElementById("m_saver");
    var iMethod = document.getElementById("method");
    
    if(method == 1)
    {
        mLogin.className = "m_sel";
        mSleep.className = "m_dis";
        iMethod.src = "Images/login.png";
    }
    else
    {
        mLogin.className = "m_dis";
        mSleep.className = "m_sel";
        iMethod.src = "Images/saver.png";
    }
}

//
// Called to open CH4 Productions
//
function ch4_click(event)
{
    widget.openURL("http://ch4productions.com/");
}

//
// Toggles if the popup settings are visable
//
function togglePopup(event)
{
    var ops = document.getElementById("popout");
    var flp = document.getElementById("flipper_img");
    
    popupVis = !popupVis;
   
    if(popupVis)
        flp.src = "Images/arrow_down.png";
    else
        flp.src = "Images/arrow_over.png";

    fader = setTimeout('fadePopup()', 30);
}

//
// Fade in and out the popup preferences window
//
function fadePopup()
{
    var ops = document.getElementById("popout");
    var val = Number(ops.style.opacity);
    
    if(popupVis)
        val += 0.2;
    else
        val -= 0.2;
    
    if(val > 1.0)
        val = 1.0;
    else if(val < 0.0)
        val = 0.0;
    
    ops.style.opacity = val;

    if(val == 0.0 || val == 1.0)
    {
        clearTimeout(fader);
        fader = null;
    }
    else
    {
        fader = setTimeout('fadePopup()', 30);
    }
}

//
// Toggles the sleep preference
//
function sleepToggle(event)
{
    instaSleep = !instaSleep;
    if(instaSleep == true)
        widget.setPreferenceForKey("YES", "instaSleep");
    else
        widget.setPreferenceForKey("NO", "instaSleep");
    updateInstaSleep();
}

//
// Changes the method to opening the login window
//
function methodLogin(event)
{
    method = 1;
    widget.setPreferenceForKey("" + method, "method");
    updateMethod();
}

//
// Changes the method to opening the screen saver
//
function methodSaver(event)
{
    method = 2;
    widget.setPreferenceForKey("" + method, "method");
    updateMethod();
}

//
// Called when a key is hit on the timer text field
//
function timerChange(event)
{
    if(event.keyCode == 13)
    {
        saveNow();
        return;
    }

    alert("timerChange");
    
    if(timeout != null)
    {
        clearTimeout(timeout);
        timeout = null;
    }
    
    timeout = setTimeout('timerTick()', 1000);
    timer = 3;
    
    var timg = document.getElementById("t_timer");
    timg.src = "Images/s" + timer + ".png";
}

//
// Called when the value for sleep is set
//
function saveNow()
{
    clearTimeout(timeout);
    timeout = null;
        
    timer = 0;
    
    var timg = document.getElementById("t_timer");
    timg.src = "Images/s" + timer + ".png";

    timerTick();
}

//
// Counts down to changing the lock delay preference
//
function timerTick()
{
    timer -= 1;
    
    if(timer <= 0)
    {
        timer = 0;
        var fad = document.getElementById("m_fader");
        var tmr = document.getElementById("m_timer");
        var val = parseInt(tmr.value);
        if(val == -1)
        {
            widget.system("/usr/bin/defaults write "
                + "com.apple.screensaver askForPassword -int 0", null);
            widget.system("osascript -e 'tell application \"ScreenSaverEngine\" to quit'", false);
            if(window.PadlockPlugin)
                PadlockPlugin.updatePrefs();
            startFadeChangeBox(true);
        }
        else if(val >= 0)
        {
            var val2 = val * 60;
            widget.system("/usr/bin/defaults write "
                + "com.apple.screensaver askForPassword -int 1", null);
            widget.system("/usr/bin/defaults write "
                + "com.apple.screensaver askForPasswordDelay -float " + val2, null);
            widget.system("osascript -e 'tell application \"ScreenSaverEngine\" to quit'", false);
            if(window.PadlockPlugin)
                PadlockPlugin.updatePrefs();
            startFadeChangeBox(true);
        }
        else
            startFadeChangeBox(false);
    }
    else
    {
        timeout = setTimeout('timerTick()', 1000);
    }
    
    var timg = document.getElementById("t_timer");
    timg.src = "Images/s" + timer + ".png";
}

//
// Starts the fade when the sleep lock time is saved
//
function startFadeChangeBox(goodChange)
{
    if(timeFade != null)
        clearTimeout(timeFade);
    
    var fad = document.getElementById("f_timer");
    if(goodChange)
        fad.style.background = "#0a0";
    else
        fad.style.background = "#a00";
    fad.style.opacity = 0.6;
    
    timeFade = setTimeout('fadeChangeBox()', 35);
}

//
// Fade notification for sleep lock time saved
//
function fadeChangeBox()
{
    var fad = document.getElementById("f_timer");
    var val = fad.style.opacity;
    
    if(val > 0.1)
        val -= 0.05;
    else
        val = 0.0;
    fad.style.opacity = val;
    
    if(val > 0.0)
        timeFade = setTimeout('fadeChangeBox()', 35);
}

//
// Perform the actions Padlock is designed for
//
function lockClick(event)
{
    if(method == 1)
        widget.system("\"/System/Library/CoreServices/Menu Extras/User.menu/"
            + "Contents/Resources/CGSession\" -suspend", false);
    else
        widget.system("osascript -e 'tell application \"ScreenSaverEngine\" to activate'", false);
        //widget.system("/System/Library/Frameworks/screensaver.framework/Resources/"
        //    + "screensaverEngine.app/Contents/MacOS/screensaverEngine", false);
    
    // use "Finder" instead of "System Events"?
    if(instaSleep)
        widget.system("osascript -e 'tell application \"System Events\" to sleep'", false);
}