/*
This work is licensed under a Creative Commons License.

<rdf:RDF xmlns="http://web.resource.org/cc/"
    xmlns:dc="http://purl.org/dc/elements/1.1/"
    xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
<Work rdf:about="">
   <dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
   <license rdf:resource="http://creativecommons.org/licenses/by/2.0/" />
</Work>

<License rdf:about="http://creativecommons.org/licenses/by/2.0/">
   <permits rdf:resource="http://web.resource.org/cc/Reproduction" />
   <permits rdf:resource="http://web.resource.org/cc/Distribution" />
   <requires rdf:resource="http://web.resource.org/cc/Notice" />
   <requires rdf:resource="http://web.resource.org/cc/Attribution" />
   <permits rdf:resource="http://web.resource.org/cc/DerivativeWorks" />
</License>

</rdf:RDF>
*/

function pdb(debugText){
    var debug = document.getElementById("debug");

    if("" == debug.style.display || "none" == debug.style.display){
	debug.style.display = "block";
    }
    
    debug.innerText += debugText;
}


function pdbln(debugLine){
    pdb(debugLine);
    pdb("\n");
}


function pdbcl(){
    var debug = document.getElementById("debug");
    debug.innerText = "";
    debug.style.display = "none";
}


function swapBalloon(){
    var notit = document.getElementById("notit");
    alert("swap:" + notit.src);
    if(notit.src.match(/notit.png/)){
        notit.src = "img/nope.png";
        alert("1");
    }else if(notit.src.match(/nope.png/)){
        notit.src = "img/nadda.png";
        alert("2");
        
    }else if(notit.src.match(/nadda.png/)){
        notit.src="img/notit.png";
        alert("3");
    }
}

var outdelay;
var labelshown;
var animation;
var animator;

function frontMove(){
	if (outdelay !== undefined){
		clearTimeout(outdelay);
		outdelay = undefined;
	}
	if (labelshown){
		return;
	}
	var from = 0.0;
	var duration = 500;
	if (animation !== undefined){
		from = animation.now;
		duration = (new Date).getTime() - animator.startTime;
		animator.stop();
	}
	
	labelshown = true;
	
	var tmpanimator = new AppleAnimator(duration, 13);
	tmpanimator.oncomplete = animationComplete;
	animator = tmpanimator;
	
	animation = new AppleAnimation(from, .85, updateOpacity);
	animator.addAnimation(animation);
	animator.start();
}

function frontOutDelay(event){
	if (outdelay === undefined){
		outdelay = setTimeout(frontOut, 0, null);
	}
}


function frontOut()
{
	if (outdelay !== undefined){
		clearTimeout(outdelay);
		outdelay = undefined;
	}
	if (!labelshown){
		return;
	}
	
	var from = .85;
	var duration = 500;
	if (animation !== undefined){
		from = animation.now;
		duration = (new Date).getTime() - animator.startTime;
		animator.stop();
	}
	
	var tmpanimator = new AppleAnimator(duration, 13);
	tmpanimator.oncomplete = animationComplete;
	animator = tmpanimator;
	
	animation = new AppleAnimation(from, 0.0, updateOpacity);
	animator.addAnimation(animation);
	animator.start();

	labelshown = false;
}


function updateOpacity(animation, now, first, done){
	document.getElementById("toggle").style.opacity = now;
}

function animationComplete(){
	animation = undefined;
	animator = undefined;
}