/*
This work is licensed under a Creative Commons License.

<rdf:RDF xmlns="http://web.resource.org/cc/"
    xmlns:dc="http://purl.org/dc/elements/1.1/"
    xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
<Work rdf:about="">
   <dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
   <license rdf:resource="http://creativecommons.org/licenses/by/2.0/" />
</Work>

<License rdf:about="http://creativecommons.org/licenses/by/2.0/">
   <permits rdf:resource="http://web.resource.org/cc/Reproduction" />
   <permits rdf:resource="http://web.resource.org/cc/Distribution" />
   <requires rdf:resource="http://web.resource.org/cc/Notice" />
   <requires rdf:resource="http://web.resource.org/cc/Attribution" />
   <permits rdf:resource="http://web.resource.org/cc/DerivativeWorks" />
</License>

</rdf:RDF>
*/

if (window.widget){
    widget.onshow = onshow;
    widget.onhide = onhide;
}


function firstLoad(){
    new AppleGlassButton(document.getElementById("cancel"), "Cancel", cancelClicked);
    new AppleGlassButton(document.getElementById("ok"), "Ok", okClicked);
    document.getElementById("notit").src = "img/nadda.png";
}


function onhide(){
    //Kill all processing here.
    document.getElementById("spinner").style.display="none";
    document.getElementById("shadow").style.display = "none";
	document.getElementById("whoops").style.display="none";

}


function onshow(){
    var front = document.getElementById("frontImage");
    var balloon = document.getElementById("balloon");
    var toggle = document.getElementById("toggle");
    
    document.getElementById("notit").src = "img/nadda.png";
    
    if(isSharing()){
        front.src = "img/share.png";        
        balloon.src = "img/turnoff.png";
        toggle.src = "img/x.png";
        toggle.onclick = toggleOffClicked;
        
    }else{
        front.src = "Default.png";
        balloon.src = "img/turnon.png";
        toggle.src = "img/shake.png";
        toggle.onclick = toggleOnClicked;
    }
    
    document.getElementById("spinner").style.display="none";
    document.getElementById("shadow").style.display = "none";
    toggle.style.display = "block";
    toggle.style.opacity = 0;
    labelshown = false;
}


function toggleOnClicked(){
    document.getElementById("whoops").style.display = "none";
    setIsSharing(true);    
}


function toggleOffClicked(){
    document.getElementById("whoops").style.display = "none";
    setIsSharing(false);    
}


function cancelClicked(){
	document.getElementById("spinner").style.display = "block";
    document.getElementById("shadow").style.display = "block";
    document.getElementById("balloon").style.display = "none";
    document.getElementById("sheet").style.display = "none";
    document.getElementById("password").value = "";
	command.write("\r");
}


function okClicked(){
	document.getElementById("spinner").style.display = "block";
    document.getElementById("shadow").style.display = "block";
    document.getElementById("balloon").style.display = "none";
    document.getElementById("sheet").style.display = "none";
    document.getElementById("notit").style.display = "none";
    var thing = document.getElementById("password").value;
    command.write(thing +"\n");
}


function commandError(thing){
    var password = document.getElementById("password");
    var balloon = document.getElementById("balloon");
    var notit = document.getElementById("notit");


    if(thing.match(/Sorry, try again./)){
        document.getElementById("spinner").style.display = "none";
        document.getElementById("shadow").style.display = "none";
        swapBalloon();
    	password.value = "";
        balloon.style.display = "none";        
		notit.style.display = "block";        
    }
    
    if(thing.match(/Password:/)){
        document.getElementById("spinner").style.display = "none";
        document.getElementById("shadow").style.display = "none";
    	document.getElementById("toggle").style.display = "none";
        if(notit.style.display != "block"){
    	    balloon.style.display = "block";
	    }   
    	document.getElementById("sheet").style.display = "block";
    	password.focus();            
    }

}


function commandDone(thing){
    if(0 == thing.status){//Everything's ok. Nothing to see here.
        document.getElementById("balloon").style.display = "none";
        document.getElementById("notit").style.display = "none";
        document.getElementById("sheet").style.display = "none";
        document.getElementById("password").value = "";

        document.getElementById("toggle").style.display = "none";
        document.getElementById("spinner").style.display = "block";    
        document.getElementById("shadow").style.display = "block";

		//This is not elegant. 
		//It turns out that `ps` lags behind in reporting the life and
		//death of AppleFileServer. Even though the command that starts
		//or kills it returns, if we check for its existance right away,
		//we may get old data. Thus the 5 second wait.
		
		//5 seconds seems to be a good time. My 800Mhz G4 even catches up
		//by that time!
        setTimeout("onshow()",5000);

		
    }else if(1 == thing.status){//sudo errored out (bad paddword)
		document.getElementById("spinner").style.display = "none";
        document.getElementById("shadow").style.display = "none";
        document.getElementById("toggle").style.display = "block";
        document.getElementById("toggle").style.opacity = 0;
        labelshown = false;
        document.getElementById("balloon").style.display = "none";
        document.getElementById("sheet").style.display = "none";
        document.getElementById("password").value = "";
        document.getElementById("notit").style.display = "none";
        document.getElementById("whoops").style.display = "block";
        
    }else{
        pdb("Oops! Check console.log");
        alert("\nOutput: "+thing.outputString+"\nError: "+thing.errorString+"\nStatus: "+thing.status);
    }
}



