// -----------------------------------------------------------------------
//  SkyMonitor (Thomas Bouve - crahan@n00.be - http://n00.be/widgets)
// -----------------------------------------------------------------------
var curlcommand = null;
var timer = null;
var interval = 300 // seconds
var prefsShowing = false;
var progInd;
var curltmpfile;
var cookiefile;

// -----------------------------------------------------------------------
//  Initialization
// -----------------------------------------------------------------------
function setup() 
{
    // set the label text
    //document.getElementById('pathlabel').innerText = getLocalizedString('Proxy:');
	document.getElementById('userlabel').innerText = getLocalizedString('User:');
	document.getElementById('passlabel').innerText = getLocalizedString('Pass:');
	
	progInd = new ProgressIndicator(document.getElementById('spinner'), "Images/prog");

    // Load Preferences into input fields
	if (window.widget)
	{
        /*pref = widget.preferenceForKey(createKey("proxy"));
		if (pref != null)
		{
			document.getElementById("pathinput").value = pref;
		}*/
				
		pref = widget.preferenceForKey(createKey("user"));
		if (pref != null)
		{
			document.getElementById("userinput").value = pref;
		}

		pref = widget.preferenceForKey(createKey("pass"));
		if (pref != null)
		{
			document.getElementById("passinput").value = pref;
		}		
	}

    curltmpfile = "/tmp/" + widget.identifier + "_out.tmp";
    cookiefile = "/tmp/"+ widget.identifier + "_cookie";
	createGenericButton(document.getElementById('done'), getLocalizedString('Done'), hidePrefs);
}


// -----------------------------------------------------------------------
//  Widget event handlers
// -----------------------------------------------------------------------
if (window.widget) 
{
	widget.onshow = onshow;
	widget.onhide = onhide;
	widget.onremove = onremove;
}

function onshow() 
{   
    if(!prefsShowing){
        //alert("Debug: onshow called");
        // start the timer and fetch the data
        if (timer == null) { 
            fetchData(); 
            timer = setInterval("fetchData();", interval*1000); 
        } 
    }
}

function onhide () 
{
    if(!prefsShowing)
    {
        //alert("Debug: onhide called");
        // stop the timer and cancel any downloads
        if(timer != null)
        {
            // alert("Debug: timer cancelled");
            clearInterval(timer);
            timer = null;  
            cancelFetchData();
        }
    }
}

function onremove () 
{
	if (window.widget) 
	{
        // stop the timer and cancel downloads, just in case
        onhide();
        // delete the tmp file
        deleteTmpFile();
		widget.setPreferenceForKey (null, createKey("user"));
		widget.setPreferenceForKey (null, createKey("pass"));
		//widget.setPreferenceForKey (null, createKey("proxy"));
	}
}


// -----------------------------------------------------------------------
//  Download the skynet volumemeter webpage
// -----------------------------------------------------------------------
function fetchData()
{
    //if (curlcommand != null)
    //{
    //    alert("Debug: not starting curl, its still running");
    //}
    if(userinput.value && passinput.value && (curlcommand == null))
    {
        //debug("Debug: starting curl, none was running");
        progInd.start();
        var url = "https://e-care.skynet.be/index.cfm?function=connection.getVolume";
        var commandstring = "/usr/bin/curl --connect-timeout 60 -s -k -L -c "+ cookiefile + " -b " + cookiefile;
        commandstring += " -d \"form_login=" + userinput.value +  "&form_password=" + passinput.value + "&Langue_Id=2&fuseaction=CheckLoginConnection\"";    
        commandstring += " " + url + " > " + curltmpfile;
        curlcommand = widget.system(commandstring, endHandler);  
    }
    else
    {
        showMessage(getLocalizedString('Not configured'));
    }
}


// -----------------------------------------------------------------------
//  Abort downloading the webpage
// -----------------------------------------------------------------------
function cancelFetchData(){
    if(curlcommand != null)
    {
        // alert("Debug: curlcommand cancelled");
        try {
            curlcommand.cancel();
            curlcommand = null;
            deleteCookie();
        } catch (ex) {}
    }
    progInd.stop();
}


// -----------------------------------------------------------------------
//  When the curlcommand finishes, call this function
// -----------------------------------------------------------------------
function endHandler(command) {
    if(command.status != 0 )
    {
        showMessage(getLocalizedString('No network connection'));
    }
    else 
    {
        var output = readInFile(curltmpfile);
        
        regexp = /Basic monthly volume:/;
        if(!regexp.test(output))
        {
            // nope, make sure we skip the parsing stage
            showMessage(getLocalizedString('Authentication error'));
        }
        else {
            // ok, go parse
            parseOutput(output);
        }
    }
    // remove cookie
    deleteCookie();
    // reset the command var
    curlcommand = null;
    // stop the spinner
    progInd.stop();
}


// -----------------------------------------------------------------------
//  Parse webpage data
// -----------------------------------------------------------------------
function parseOutput(output)
{
    var basicused = "";
    var basicmax = "";
    var packused = "";
    var packmax = "";
	var unit1 = "";
	var unit2 = "";
    var packsremaining = "";
    var match = "";    
    //regexp = /\s*(\d*\.*\d*)\s*(\w\w)<\/strong> out of\s*<strong>(\d+)\s+(\w\w)<\/strong>/;
    regexp = /Monthly volume used\s*<strong>(\d*\.*\d*)\s*(\w\w)<\/strong> out of\s*<strong>(\d+)\s+(\w\w)<\/strong>/;
	regexp2 = /Monthly volume used\s*<strong>(\d*\.*\d*)\s*GB\s*(\d*\.*\d*)\s*MB<\/strong> out of\s*<strong>(\d+)\s+(\w\w)<\/strong>/;
	// we have xx GB yy MB
	if(regexp2.test(output)){
		match = regexp2.exec(output);
		basicused = (match[1]*1) + decRound(match[2]/1024,2);
		basicmax = match[3];
		unit2 = match[4];
		if(unit2 == "MB") basicmax = decRound(basicmax/1024,2);
	}
	// we got xx (MB|GB)
	else if(regexp.test(output)){
		match = regexp.exec(output);
	    basicused = match[1];
		unit1 = match[2];
	    basicmax = match[3];
		unit2 = match[4];
		// check if we have megs or gigs
		if(unit1 == "MB") basicused = decRound(basicused/1024,2);
		if(unit2 == "MB") basicmax = decRound(basicmax/1024,2);
	}
	  
	// volume pack data
    regexp = /You used\s*<strong>(\d*\.*\d*)\s*(\w\w)<\/strong> out of\s*<strong>(\d+)\s*(\w\w)<\/strong> available in the current Volume Pack/;
   	regexp2 = /You used\s*<strong>(\d*\.*\d*)\s*GB\s*(\d*\.*\d*)\s*MB<\/strong> out of\s*<strong>(\d+)\s*(\w\w)<\/strong> available in the current Volume Pack/;
	if(regexp2.test(output)){
		match = regexp2.exec(output);
		packused = (match[1]*1) + decRound(match[2]/1024,2);
		packmax = match[3];
		unit2 = match[4];
		if(unit2 == "MB") packmax = decRound(packmax/1024,2);
	}
	else if(regexp.test(output))
    {
        match = regexp.exec(output);
        packused = match[1];
		unit1 = match[2];
        packmax = match[3];
		unit2 = match[4];
		
		// check for megs or gigs
		if(unit1 == "MB") packused = decRound(packused/1024,2);
		if(unit2 == "MB") packmax = decRound(packmax/1024,2);
    }
    else
    {
        packused = 0;
        packmax = 0;
    }
    
    // test for unused volume packs
    regexp = /you still have <strong>(\d*)<\/strong> unused Volume Pack/;
    if(regexp.test(output))
    {
        match = regexp.exec(output);
        packsremaining = match[1];
    }
    else
    {
        packsremaining = 0;
    }        

    // set everything so it all shows nicely
    if((basicused/basicmax) == 1)
    {
        document.getElementById("basicvumeter").style.width = "192px";
        document.getElementById("basiclabel").innerText = getLocalizedString('Basic volume:')+" "+getLocalizedString('all used');
    }
    else
    {
        document.getElementById("basicvumeter").style.width = calcVUValue(basicused, basicmax)+"px";
        document.getElementById("basiclabel").innerText = getLocalizedString('Basic volume:')+" "+basicused+"GB / "+basicmax+"GB";
    }

    if(packmax == 0)
    {
        document.getElementById("packvumeter").style.width = "0px";
        document.getElementById("packlabel").innerText = getLocalizedString('Volume pack:')+" "+getLocalizedString('none');
    }
    else
    {
        document.getElementById("packvumeter").style.width = calcVUValue(packused, packmax)+"px";
        var packstring = getLocalizedString('Volume pack:')+" "+packused+"GB / "+packmax+"GB"; 
        if(packsremaining > 0)
        {
            packstring += " (+" + packsremaining +")";
        }
        document.getElementById("packlabel").innerText = packstring; 
    } 
}


// -----------------------------------------------------------------------
//  Helper functions
// -----------------------------------------------------------------------
function readInFile(filename) 
{ 
    req = new XMLHttpRequest(); 
    req.open("GET", filename ,false); 
    req.send(null); 
    response = req.responseText; 
    if (response) 
    { 
        return response; 
    } 
    return null 
}

function showMessage (message)
{
    document.getElementById("basiclabel").innerText = message;
    document.getElementById("packlabel").innerText = "";
    document.getElementById("basicvumeter").style.width = "0px";
    document.getElementById("packvumeter").style.width = "0px";
}

function calcVUValue(used, max) 
{
    return Math.round((used/max)*31)*6;
}

function decRound(value, decimals)
{
    var shift = Math.pow(10,decimals);
    return Math.round(value*shift)/shift;
}

function deleteTmpFile(){
    try {
        widget.system("/bin/rm " + curltmpfile, null);
    } catch (ex) {}
}

function deleteCookie()
{
    try {
        widget.system("/bin/rm " + cookiefile, null);
    } catch (ex) {}
}


// -----------------------------------------------------------------------
//  Spinner animation 
// -----------------------------------------------------------------------
// Copied from the Wikipedia widget created by Sean Billig
// Website: http://www.whatsinthehouse.com/widgets/
function ProgressIndicator(element, imageBaseURL) {
    this.count = 0;
    this.timer = null;
    this.element = element;
    this.element.style.display = "none";
    this.imageBaseURL = imageBaseURL;
}

ProgressIndicator.prototype = {
    start : function () {
        this.element.style.display = "block";        
        if (this.timer) clearInterval(this.timer);
        this.tick();
        var localThis = this;
        this.timer = setInterval (function() { localThis.tick() }, 60);
    },

    stop : function () {
        clearInterval(this.timer);
        this.element.style.display = "none";
    },

    tick : function () {
        var imageURL = this.imageBaseURL + (this.count + 1) + ".png";
        this.element.src = imageURL;
        this.count = (this.count + 1) % 12;
    }
}


// -----------------------------------------------------------------------
//  Preference functions (key creation and saving)
// -----------------------------------------------------------------------
function createKey(key) 
{
	return widget.identifier + "-" + key;
}

function prefChanged(select, key) 
{
	if (window.widget) 
	{
		//alert("Setting key "+createKey(key)+" to value "+select.value);
		widget.setPreferenceForKey(select.value, createKey(key));
	}
}




// -----------------------------------------------------------------------
//  Dashboard Code (from apple)
// -----------------------------------------------------------------------
function getLocalizedString (key)
{
    try {
        var ret = localizedStrings[key];
        if (ret === undefined)
            ret = key;
        return ret;
    } catch (ex) {}
    return key;
}

function showPrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToBack");
       
	front.style.display="none";
	back.style.display="block";
	exitflip(event);

	if (window.widget)
		setTimeout ('widget.performTransition();', 0);  
		
    // stop any timers or downloads
    onhide();
    prefsShowing = true;
}

function hidePrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToFront");
      
	back.style.display="none";
	front.style.display="block";

	if (window.widget)
		setTimeout ('widget.performTransition();', 0);
		
    // restart timer and fetch data
    prefsShowing = false;
    onshow();
}

var flipShown = false;
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};

function mousemove (event)
{
	if (!flipShown)
	{
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
 
		var starttime = (new Date).getTime() - 13;
 
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 1.0;
		animate();
		flipShown = true;
	}
}
function mouseexit (event)
{
	if (flipShown)
	{
		// fade in the info button
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}

		var starttime = (new Date).getTime() - 13;

		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}

function animate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
   

	T = limit_3(time-animation.starttime, 0, animation.duration);

	if (T >= animation.duration)
	{
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}

	animation.firstElement.style.opacity = animation.now;
}

function limit_3 (a, b, c)
{
	return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease)
{
	return from + (to - from) * ease;
}

// these functions are called when the info button itself receives onmouseover and onmouseout events

function enterflip(event)
{
	document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event)
{
	document.getElementById('fliprollie').style.display = 'none';
}

