/*
	Copyright(C)2005 Chris Benjaminsen
	http://widgets.lol.dk

	This widget is freeware, and released under a creative commons
	licance: http://creativecommons.org/licenses/by-nc-sa/2.5/
*/

Debug = {
	elm:document.getElementById('debug'),
	Out:function(out){
		this.elm.innerHTML += '| ' +  out;
	},
	Write:function(out){
		this.elm.innerHTML = out;
	}
}

var Bar = {
	elm:document.getElementById('bar'),
	barElm:document.getElementById('viewer'),
	sysElm:document.getElementById('sysBar'),
	txtElm:document.getElementById('viewertext'),
	IsVisible:true,
	ToggleDisplay:function(display){
		if( this.IsVisible = display ){
			this.elm.style.display = ''
		}else{
			this.elm.style.display = 'none'
		}
		sizeOffset = 0;
		DoResize()
	},
	Update:function(data){
		if( Config.show == "3" ) return false
		this.txtElm.innerHTML = ( data[0] >> 0 ) + '%'
		this.barElm.style.backgroundPosition = "0 " + ( 116 - 57/100*data[0] >> 0 )
		//this.sysElm.style.backgroundPosition = "0 " + ( 116 - 58/100*data[1] >> 0 )
	}
}


var plotterWidth = 200
var graphbackground = new Image();
graphbackground.src = 'images/plotterbackground.png';
var Graph = {
	elm:document.getElementById('graph'),
	context:document.getElementById('plotter').getContext("2d"),
	IsVisible:true,
	ToggleDisplay:function(display){
		if( this.IsVisible = display ){
			this.elm.style.display = ''
		}else{
			this.elm.style.display = 'none'
		}
		sizeOffset = 0;
		DoResize()
	},
	DrawGraph:function(arr){
		if( Config.show == "2" ) return false
		var length = arr.length
		this.context.clearRect(0,0,plotterWidth,80)
		this.context.save();
		this.context.moveTo(plotterWidth,80)
		for(var i = 0; i < length ; i++){

			var x = (length-1-i)*plotterWidth/(length-1)
			var y = 80-80/100*(arr[i] ? arr[i][0] : 0)

			this.context.lineTo(x,y);
		}
		this.context.lineTo(0,80)
		this.context.clip()
		this.context.drawImage(graphbackground,0,0)
		this.context.restore();

		this.context.lineWidth = 1;
		this.context.strokeStyle = 'rgb(0, 0, 255)';
		for(var i = 0; i < length; i++){

			var x = (length-1-i)*plotterWidth/(length-1)
			var y = 80-80/100*(arr[i] ? arr[i][0] : 0)

			i ?  this.context.lineTo(x,y) : this.context.moveTo(x,y);
		}
		this.context.stroke()
		
		if( Config.showInactive ){
			this.context.lineWidth = 1;
			this.context.strokeStyle = 'rgba(0, 0, 255, .5)';
			for(var i = 0; i < length; i++){

				var x = (length-1-i)*plotterWidth/(length-1)
				var y = 80-80/100*(arr[i] ? arr[i][1] : 0)

				i ?  this.context.lineTo(x,y) : this.context.moveTo(x,y);
			}
			this.context.stroke()
		}
		
	}
}

Data = {
	data: new Array(97),
	setValue: function(val){
		this.data = [val].concat( this.data )
		this.data.pop()
	},
	getFirstValue: function(){
		return this.data[0]
	},
	getData:function(){
		return this.data
	}
}

Config = {
	updateSpeed:null, show:null, checked:null, showText:null, command:null, showInactive:null,
	LoadConfig:function(){
		this.updateSpeed = widget.preferenceForKey('updateSpeed') || 2
		this.show = widget.preferenceForKey('show') || 1
		this.checked = widget.preferenceForKey('checked') == true 
		this.showText = widget.preferenceForKey('showText') == true 
		this.showInactive = widget.preferenceForKey('showText') == true 

		document.getElementById('updateSpeed').selectedIndex = this.updateSpeed-1
		document.getElementById('showSelect').selectedIndex = this.show-1
		document.getElementById('backgroundUpdate').checked = this.checked
		document.getElementById('showText').checked = this.showText
		document.getElementById('showInactive').checked = this.showInactive
		
		SetDisplay(this.show)
	},
	SetConfig:function(){
		widget.setPreferenceForKey(this.updateSpeed,'updateSpeed')	
		widget.setPreferenceForKey(this.show,'show')	
		widget.setPreferenceForKey(this.checked,'checked')	
		widget.setPreferenceForKey(this.showText,'showText')	
		widget.setPreferenceForKey(this.showInactive,'showInactive')	
		this.TakeEffect()
	},
	TakeEffect:function(){
		if( this.command )this.Unload()
		this.command = widget.system("/usr/bin/top -R -T -F -n0 -ovsize -s " + this.updateSpeed,function(data){})
		this.command.onreadoutput = function(data){
			var usedMem = (/([0-9\.]+)([M|G]) used/gi).exec(data) 
			var freeMem = (/([0-9\.]+)([M|G]) free/gi).exec(data)
			var inactiveMem = (/([0-9\.]+)([M|G]) inactive/gi).exec(data)
			if( usedMem && freeMem && inactiveMem){
				
				usedMem = getValue(usedMem)
				freeMem = getValue(freeMem)
				inactiveMem = getValue(inactiveMem)
				
				var totalMem = usedMem + freeMem
				if( totalMem ){
					Data.setValue( [ (usedMem/totalMem)*100 , (inactiveMem/totalMem)*100 ] )
				}
				if( visible ){
					Graph.DrawGraph(Data.getData())
					Bar.Update(Data.getFirstValue())
				}
				if( Config.showText ){
					var outString = ""
					var totalMem = Math.ceil(totalMem/8)*8
					outString += "Used memory: " + getText(usedMem) + "<br/>"
					outString += "Inactive memory: " + getText(inactiveMem) + "<br/>"
					outString += "Free memory: " + getText(freeMem)
					document.getElementById('processes').innerHTML = outString;
				}
			}
			
			function getValue(inArr){
				return parseFloat(inArr[1]) * ( inArr[2] == "G" ? 1024 : 1 ) 
			}			
			function getText(val){
				var ext = "MB"
				if( val > 1024 ){
					 val /= 1024
					 ext = "GB"
				}
				val = Math.round(val*10)/10
				return val + ext
			}			
		}	
		
		document.getElementById('processes').style.display = this.showText ? '' : 'none'

	},
	Unload:function(){
		this.command.write('q')
		this.command.cancel()
		this.command.close()
	}
}


var sizeOffset = 0;
function DoResize(){
	var offsetWidth				= document.body.offsetWidth

	var background				= document.getElementById('background')
	background.style.width		= ( offsetWidth - 47 ) + 'px'

	var graph					= document.getElementById('graph')
	graph.style.width			= ( offsetWidth - 94 + sizeOffset + ( Bar.IsVisible ? 0 :  58  )) + 'px'

	var plotter					= document.getElementById('plotter')
	plotter.style.width			= ( plotterWidth = ( offsetWidth - 94 + sizeOffset + ( Bar.IsVisible ? 0 :  58  ))) + 'px'

	var graphmid				= document.getElementById('graphmid')
	graphmid.style.width		= ( offsetWidth - 110 + sizeOffset + ( Bar.IsVisible ? 0 :  58  )) + 'px'

	var bar						= document.getElementById('bar')
	bar.style.width				= ( 50 - sizeOffset + ( Graph.IsVisible ? 0 :  offsetWidth - 86 )) + 'px'

	var barmid					= document.getElementById('barmid')
	barmid.style.width			= ( 34 - sizeOffset + ( Graph.IsVisible ? 0 :  offsetWidth - 86 )) + 'px'
	
	var viewer					= document.getElementById('viewer')
	viewer.style.width			= ( 40 - sizeOffset + ( Graph.IsVisible ? 0 :  offsetWidth - 86 )) + 'px'

	var viewermid				= document.getElementById('viewermid')
	viewermid.style.width		= ( 25 - sizeOffset + ( Graph.IsVisible ? 0 :  offsetWidth - 86 )) + 'px'

	var viewertext				= document.getElementById('viewertext')
	viewertext.style.width		= ( 50 - sizeOffset + ( Graph.IsVisible ? 0 :  offsetWidth - 86 )) + 'px'

	var intresizer				= document.getElementById('intresizer')
	intresizer.style.right		= ( 68 - sizeOffset ) + 'px'
	intresizer.style.display	= Bar.IsVisible && Graph.IsVisible ? '' : 'none'
	
	var width = (44 + ( Graph.IsVisible ? 50 : 0 ) + ( Bar.IsVisible ? 50 : 0 ) )
	if( document.body.offsetWidth < width   ){
		window.resizeBy(width  - document.body.offsetWidth,0)
	}
}
window.onresize = DoResize


Fader = {
	element:document.getElementById('config'),
	timer:null,
	cValue:0,
	value:0,
	step:0,
	doFade:function(){
		this.element.style.opacity = this.cValue+=this.step
		if( ( this.cValue > this.value && this.step > 0 ) || ( this.cValue < this.value && this.step < 0 ) ){ 
			this.clearTimer()
		}
	},
	clearTimer:function(){
		if( this.timer ) clearInterval(this.timer)
	},
	Fade:function(to){
		this.step = to > this.value ? .02 : -.02
		this.value = to

		var This = this
		this.clearTimer()
		this.timer = setInterval(function(){This.doFade()},10)
	}
}

window.onload = function(){
	var rightresizer = document.getElementById('rightresizer');
	var intresizer = document.getElementById('intresizer');
	var front = document.getElementById('front')
	var back = document.getElementById('back')
	var configi = document.getElementById('config')

	//Widget Resizer
	var doRightResize = false
	var rightResizerIsOver = false
	rightresizer.onmouseover = function(){
		this.src = 'images/resizeover.png'
		rightResizerIsOver = true
	}

	rightresizer.onmouseout = function(){
		if( !doRightResize ) this.src = 'images/resize.png' 
		rightResizerIsOver = false
	}

	rightresizer.onmousedown = function(){
		doRightResize = true
	}
	
	//Internal Resizer
	var doIntResize = false
	var intResizerIsOver = false
	intresizer.onmouseover = function(){
		this.src = 'images/resizeover.png'
		intResizerIsOver = true
	}

	intresizer.onmouseout = function(){
		if( !doIntResize ) this.src = 'images/resize.png' 
		intResizerIsOver = false
	}

	intresizer.onmousedown = function(){
		doIntResize = true
	}
	
	//Generic resize handler
	front.onmouseup = function(){
		if( !rightResizerIsOver ) rightresizer.src = 'images/resize.png' 
		if( !intResizerIsOver ) intresizer.src = 'images/resize.png' 
		doIntResize = doRightResize = false
	}	
	
	var cords = [0,0]
	front.onmousemove = function(e){
		var offset = e.x-cords[0]
		if( doRightResize ){
			if( document.body.offsetWidth + offset > 1000  ){
				doRightResize = false;
				return false
			}
			if( document.body.offsetWidth + offset > 43 + ( Graph.IsVisible ? 50 : 0 ) + ( Bar.IsVisible ? 50 : 0 )){
				sizeOffset = Math.max(sizeOffset, -document.body.offsetWidth-offset + 44 + ( Graph.IsVisible ? 50 : 0 ) + ( Bar.IsVisible ? 50 : 0 ))
				window.resizeBy(offset,0)
			}
		}

		if( doIntResize ){
			sizeOffset += offset
			sizeOffset = Math.min(sizeOffset,0)
			sizeOffset = Math.max(sizeOffset,-document.body.offsetWidth + 44 + ( Graph.IsVisible ? 50 : 0 ) + ( Bar.IsVisible ? 50 : 0 ))
			DoResize()
		}
		cords = [e.x,e.y]
	}
	
	front.onmouseout = function(e){
		front.onmousemove(e)
		Fader.Fade(0)
	}
	
	createGenericButton (document.getElementById('done'), 'Done', function(){
		var newSize = configSize - document.body.offsetWidth;
		window.resizeBy(newSize,0)
		widget.prepareForTransition("ToFront");
		front.style.display = 'block'
		back.style.display = 'none'
		setTimeout(function(){
			widget.performTransition()
		},1)
	},67);

	front.onmouseover = function(){	Fader.Fade(1) }
	configi.onmouseover = function(){
		this.style.background = 'url(images/white_rollie.png)'
	}
	configi.onmouseout = function(){
		this.style.background = 'none'
	}
	
	var configSize = 0
	configi.onclick = function(){
		configSize = document.body.offsetWidth;
		var newSize = 294 - configSize
		if( document.body.offsetWidth < 294 ) window.resizeBy(newSize,0)
		widget.prepareForTransition("ToBack");
		front.style.display = 'none'
		back.style.display = 'block'
		setTimeout(function(){
			widget.performTransition()
		},0)

	}	
	document.getElementById('showSelect').onchange = function(){
		SetDisplay(this.value)
		Config.show = this.value
		Config.SetConfig()
	}
	

	
	document.getElementById('updateSpeed').onchange = function(){
		Config.updateSpeed = this.value
		Config.SetConfig()
	}
	
	document.getElementById('backgroundUpdate').onchange = function(){
		Config.checked = this.checked 
		Config.SetConfig()
	}

	document.getElementById('showText').onchange = function(){
		Config.showText = this.checked 
		Config.SetConfig()
	}
	document.getElementById('showInactive').onchange = function(){
		Config.showInactive = this.checked 
		Config.SetConfig()
	}

	var links = document.getElementsByTagName('a')
	for( var a=0;a<links.length;a++){
		links[a].onclick = function(){
			widget.openURL(this.href)
			return false
		}
	}


	Config.LoadConfig()
	Config.TakeEffect()
	
}


var visible = true
if (window.widget){
	widget.onhide = function(){
		visible = false
		if( !Config.checked ){
			Config.Unload()
		}
	}
	widget.onshow = function(){
		visible = true
		if( !Config.checked ){
			Config.TakeEffect()
		}
	}
}

function SetDisplay(value){
	switch(value){
		case "1":{
			Graph.ToggleDisplay(true)
			Bar.ToggleDisplay(true)
			break;
		}
		case "2":{
			Graph.ToggleDisplay(false)
			Bar.ToggleDisplay(true)
			break;
		}
		case "3":{
			Graph.ToggleDisplay(true)
			Bar.ToggleDisplay(false)
			break;
		}
	}	
}
