
function Fader (element, callback, fadeTime) {
	this.element = element;
	this.startTime = 0;
	this.timer = null;
	
	this.doneNotification = callback;
	
	// Initialize for a fade-in.  These values will be reset by the fadeIn/fadeOut functions
	this.fadingIn = true;
	this.now = Math.abs(transSet);
	this.from = this.now;
	this.to = this.now;
	
	this.fadeOut = Fader_fadeOut;
	this.fadeIn = Fader_fadeIn;
	this.startFade = Fader_startFade;
	this.tick = Fader_tick;
	this.setFadeTime = Fader_setFadeTime;
	this.fadetime = fadeTime;
	this.setFadeTime(this.fadetime);
}

function Fader_fadeOut () {
	if (this.fadingIn) {
		this.startFade(this.now, 0.0);
		this.fadingIn = false;
	}
}

function Fader_fadeIn () {
	if (!this.fadingIn) {
		this.startFade(this.now, Math.abs(transSet));
		this.fadingIn = true;
	}
}

function Fader_startFade (newFrom, newTo) {
	this.from = newFrom;
	this.to = newTo;
	
	this.startTime = (new Date).getTime() - 13; // set it back one frame

	if (this.timer != null) {
		clearInterval(this.timer);
		this.timer = null;
	}
	
	var localThis = this;
	this.timer = setInterval (function() { localThis.tick() }, 13);
}


function Fader_setFadeTime (fadeTime) {
	this.fadeTime = fadeTime > 250 ? fadeTime : 250;
}


function Fader_tick() {	
	var T;
	var ease;
	var time = (new Date).getTime();
	
	// Calculate the time delta since the fade started.
	T = limit_3(time-this.startTime, 0, this.fadeTime);
	
	// The fade is over.  Clear out the timer, making this the last iteration.
	if (T >= this.fadeTime) {
		clearInterval (this.timer);
		this.timer = null;
		this.now = this.to;
		// invoke our callback, if one was set.
		if (this.doneNotification) {
			var localThis = this;
			setTimeout(function() { localThis.doneNotification(); }, 0);
		}
	} else {
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / this.fadeTime));
		this.now = computeNextFloat (this.from, this.to, ease);
	}
	
	// Set the opacity of the fading element.  Over repeated ticks,
	// this.now will go up (fade in) or down (fade out).
	
	this.element.style.opacity = this.now;
}
