/*
 * File: main.js
 *
 * Copyright (c) 2007-2010, Paulo Avila (apaulodesign.com)
 *
 * Project: Wallify Widget
 *
 * Description: Provides the necessary functions for the operation of the
 * Wallify widget - a wrapper for a command line operation that allows
 * a Screen Saver to be run on the desktop wallpaper.
 */

var g_tipElement=null;var g_tipText=null;var g_tipTimer=null;var g_tipTimerLimit=null;var g_winHeight=window.innerHeight;var g_winWidth=window.innerWidth;function Widget(a,b){this.externalURL=a;this.versionQueryURL=b;this.bundleId=this.getPlistValue("CFBundleIdentifier");this.name=this.bundleId.extension();this.version=this.getPlistValue("CFBundleVersion");this.pathToMe=window.location.pathname.replace(/[^/]*$/,"");this.isInDashboard=(typeof(window.widget)==="object")?true:false;this.isSystemAllowed=true;}Widget.prototype.showBack=function(a){if(this.isInDashboard){widget.prepareForTransition("ToBack");}document.getElementById("front").style.display="none";document.getElementById("back").style.display="block";if(this.isInDashboard){setTimeout(function(){widget.performTransition();},0);}if(typeof(a)==="function"){setTimeout(a,750);}};Widget.prototype.showFront=function(a){if(this.isInDashboard){widget.prepareForTransition("ToFront");}document.getElementById("back").style.display="none";document.getElementById("front").style.display="block";if(this.isInDashboard){setTimeout(function(){widget.performTransition();},0);}if(typeof(a)==="function"){setTimeout(a,750);}};Widget.prototype.localize=function(a){try{a=localizedStrings[a]||a;}catch(b){}return a;};Widget.prototype.instance=function(a){var b=(this.isInDashboard)?widget.identifier:"!Dashboard";if(typeof(a)==="string"&&a!==""){b+="-"+a;}return b;};Widget.prototype.escapeCLI=function(a){if(typeof(a)==="string"){a=a.replace(new RegExp("'","g"),"'\\''");}return"'"+a+"'";};Widget.prototype.escapeSCPT=function(a){if(typeof(a)==="string"){a=a.replace(/\\/g,"\\\\");a=a.replace(new RegExp('"',"g"),'\\"');}return'"'+a+'"';};Widget.prototype.getPref=function(a){var b;if(this.isInDashboard){b=widget.preferenceForKey(a);}return b;};Widget.prototype.setPref=function(a,b){if(this.isInDashboard){widget.setPreferenceForKey(b,a);}return a;};Widget.prototype.versionQuery=function(e,f,c,a){var b,d;if(typeof(this.versionQueryURL)==="string"||this.versionQueryURL!==""){b=this.versionQueryURL+"?s="+this.name+"&v="+this.version;d=new XMLHttpRequest();d.onreadystatechange=function(){switch(d.readyState){case 0:break;case 1:break;case 2:break;case 3:break;case 4:if(typeof(f)==="function"){f(b);}if(d.status===200){if(typeof(c)==="function"){c(d.responseText);}}else{if(typeof(a)==="function"){a(d.status,d.responseText);}}break;default:break;}};d.open("GET",b);d.setRequestHeader("Cache-Control","no-cache");d.send(null);if(typeof(e)==="function"){e(b);}}};Widget.prototype.getPlistValue=function(f){var b=1;var e,d;var h="";var c=null;var a=null;var g=new XMLHttpRequest();g.open("GET",window.location.pathname.replace(/[^/]*$/,"Info.plist"),false);g.send(null);c=g.responseXML.getElementsByTagName("dict")[0].childNodes;for(e=0;e<c.length;e++){if(c[e].nodeType===b&&c[e].tagName.toLowerCase()==="key"&&c[e].firstChild.data===f){if(c[e+2].tagName.toLowerCase()!=="array"){h=c[e+2].firstChild.data;}break;}}return h;};Widget.prototype.dialog=function(h,m){var e;var f=[];var g=0;var d=window.innerHeight;var k=document.createElement("div");var b=document.createElement("span");var j=document.createElement("div");var a=document.createElement("div");var c=document.createElement("div");var l=null;k.id="modal-dialog";k.appendChild(b);k.appendChild(j);k.appendChild(a);k.appendChild(c);b.setAttribute("class","bg");j.className="title";j.innerHTML=((typeof(h)==="string"&&h!=="")?h:this.localize("Alert"));a.className="message";a.innerHTML=((typeof(m)==="string"&&m!=="")?m:"");c.setAttribute("class","buttons");if(arguments.length<4){if(arguments.length<3){arguments.length++;arguments[2]=this.localize("OK");}arguments.length++;}for(e=2;e<arguments.length;e=e+2){f[(e-2)]=document.createElement("span");f[(e-2)].className="button";c.appendChild(f[(e-2)]);l=new AppleButton(f[(e-2)],arguments[e],10,"","",0,"","","","",0,arguments[(e+1)]);f[(e-2)].addEventListener("click",function(){document.getElementById("modal-dialog").style.opacity="0";setTimeout(function(){window.document.body.removeChild(k);},250);window.resizeTo(window.innerWidth,d);},false);}window.document.body.appendChild(k);g=j.clientHeight+a.clientHeight+c.clientHeight;if(d<g){window.resizeTo(window.innerWidth,g);}return k;};Widget.prototype.eId=function(a){return document.getElementById(a);};Widget.prototype.externalHTTP=function(a){if((typeof(a)!=="string"||a==="")&&(typeof(this.externalURL)==="string"&&this.externalURL!=="")){a=this.externalURL+"?s="+encodeURI(this.name)+"&v="+encodeURI(this.version);}if(this.isInDashboard){widget.openURL(a);}else{window.location.href=a;}};String.prototype.extension=function(a){var b=(this.length-1);var a=(typeof(a)==="string")?a:".";if(this.charAt(b)!==a){while(--b>0){if(this.charAt(b)===a){break;}}}return this.substr((b<=0)?this.length:(b+1));};String.prototype.noExtension=function(a){var b=(this.length-1);var a=(typeof(a)==="string")?a:".";if(this.charAt(b)!==a){while(--b>0){if(this.charAt(b)===a){break;}}}return this.substring(0,((b<=0||b===(this.length-1))?this.length:b));};"use strict";var wallify=new Widget("http://www.apaulodesign.com/widgets/index.php","http://www.apaulodesign.com/widgets/version.php");wallify.saverIndexOnDown=0;wallify.pathToActivator=wallify.pathToMe+"Assets/WallifyActivator.scpt";wallify.keySaverName="ScreenSaverOfChoice";wallify.keyPreviousQuery="PreviousVersionQuery";wallify.keyOnAtLogin="OnAtLogin";wallify.keyAutoVersionCheck="AutoVersionCheck";wallify.toBack=function(){document.getElementById("front").style.backgroundPositionY="0";setTimeout(function(){wallify.showBack();},120);};wallify.toFront=function(){wallify.showFront(function(){document.getElementById("front").style.backgroundPositionY="-75px";});};wallify.populateScreenSaverList=function(){var b,c,a;if(wallify.isInDashboard){c=widget.system("/usr/bin/whoami",null).outputString.split("\n")[0];a=[[widget.system("/bin/ls -1 '/System/Library/Screen Savers/' | /usr/bin/grep -Ev '.slideSaver$'",null).outputString,""],[widget.system("/bin/ls -1 "+wallify.escapeCLI("/Users/"+c+"/Library/Screen Savers/")+" | /usr/bin/grep -E '.saver$|.qtz$|.slideSaver$'",null).outputString,wallify.localize("LSText_MySavers")],[widget.system("/bin/ls -1 '/System/Library/Screen Savers/' | /usr/bin/grep -E '.slideSaver$'",null).outputString,wallify.localize("LSText_AppleSlideshows")],[widget.system("/bin/ls -1 '/Library/Screen Savers/' | /usr/bin/grep -E '.saver$|.qtz$|.slideSaver$'",null).outputString,wallify.localize("LSText_SystemSavers")]];}else{a=[["Sample\nScreen Saver\nNames\nFor\nTesting\nIn\nSafari\n",""],["These\nAre\nGrouped\nIn Some\nAppropriate\nCategory\n","Apple Slideshows"]];}for(b=0;b<a.length;b++){if(typeof(a[b][0])==="string"){wallify.appendScreenSavers(document.getElementById("screen-saver-list"),a[b][0].split("\n"),a[b][1]);}}};wallify.appendScreenSavers=function(h,d,f){var b,g,e,a,c=h;if(typeof(f)==="string"&&f!==""){g=document.createElement("optgroup");g.label=f;h.appendChild(document.createElement("option"));h.appendChild(g);c=g;}for(b=0;b<(d.length-1);b++){a=d[b].noExtension();e=document.createElement("option");e.value=a;e.text=a;c.appendChild(e);}};wallify.chooseSaver=function(){var a=document.getElementById("screen-saver-list"),b=a.options[a.selectedIndex].value;if(a.selectedIndex===0||b!==""){wallify.setPref(wallify.keySaverName,b);if(wallify.isActive()){wallify.activate();}}else{a.selectedIndex=wallify.saverIndexOnDown;}};wallify.activate=function(){var a=document.getElementById("screen-saver-list"),b=a.options[a.selectedIndex].value,c="/System/Library/Frameworks/ScreenSaver.framework/Resources/ScreenSaverEngine.app/Contents/MacOS/ScreenSaverEngine -background";if(typeof(b)==="string"&&b!==""){c+=" -module "+wallify.escapeCLI(b);}c+=" &> /dev/null &";if(wallify.isInDashboard){widget.system(c,function(){});}document.getElementById("front").style.backgroundPositionX="-196px";};wallify.deactivate=function(){var b,a="/usr/bin/killall -v ScreenSaverEngine";if(wallify.isInDashboard&&wallify.isActive()){b=widget.system(a,function(){});}document.getElementById("front").style.backgroundPositionX="0";};wallify.isActive=function(){var a="/bin/ps -cx | /usr/bin/grep -q 'ScreenSaverEngine'";return((widget.system(a,null).status===0)?true:false);};wallify.removeLaunchAgentsFile=function(){var c="/bin/rm -f ",b=widget.system("/usr/bin/whoami",null).outputString.split("\n")[0],a="widget-"+wallify.bundleId+".plist";c+=wallify.escapeCLI("/Users/"+b+"/Library/LaunchAgents/"+a);widget.system(c,function(){});};wallify.versionControl=function(){var a=new Date(),b=new Date(wallify.getPref(wallify.keyPreviousQuery)||null);if((a-b)>=(7*86400000)){wallify.versionQuery(wallify.versionQueryStart,wallify.versionQueryEnd,function(c){if(c!==wallify.version){wallify.dialog(wallify.localize("LSDialog_NewVersion"),"",wallify.localize("LSDialog_NotNow"),null,wallify.localize("LSDialog_GetIt"),function(){wallify.externalHTTP();});document.getElementById("modal-dialog").style.opacity="1";}wallify.setPref(wallify.keyPreviousQuery,a.getTime());});}};wallify.versionQueryStart=function(){document.getElementById("version").innerHTML="v...";};wallify.versionQueryEnd=function(){document.getElementById("version").innerHTML="v"+wallify.version;};wallify.loadSavedPrefs=function(){var c,e=document.getElementById("screen-saver-list"),b=wallify.getPref(wallify.keyAutoVersionCheck),d=wallify.getPref(wallify.keyOnAtLogin),a=wallify.getPref(wallify.keySaverName);if(typeof(b)==="boolean"){if(b){document.getElementById("auto-update").setAttribute("checked");}else{document.getElementById("auto-update").removeAttribute("checked");}}if(typeof(d)==="boolean"){if(d){document.getElementById("on-at-login").setAttribute("checked");}else{document.getElementById("on-at-login").removeAttribute("checked");}}if(typeof(a)==="string"&&a!==""){for(c=0;c<e.options.length;c++){if(a===e.options[c].value){e.selectedIndex=c;break;}}}};wallify.main=function(){var b=new AppleInfoButton(document.getElementById("info-button"),document.getElementById("front"),"white","black",function(){wallify.toBack();}),h=new AppleGlassButton(document.getElementById("done-button"),wallify.localize("Done"),function(){wallify.toFront();}),a=document.getElementById("wallify-button"),f=document.getElementById("logo"),g=document.getElementById("version"),e=document.getElementById("screen-saver-list"),d=document.getElementById("auto-update"),c=document.getElementById("on-at-login");document.body.addEventListener("keydown",function(i){if(i.altKey){document.getElementById("delay-icon").style.display="block";}},false);document.body.addEventListener("keyup",function(i){document.getElementById("delay-icon").style.display="none";},false);a.addEventListener("mousedown",function(){document.getElementById("front").style.backgroundPositionY="-150px";},false);a.addEventListener("mouseup",function(){document.getElementById("front").style.backgroundPositionY="-75px";},false);a.addEventListener("click",function(){if(event.altKey){wallify.dialog(wallify.localize("LSDialog_FullFeature"),"",wallify.localize("OK"),null,wallify.localize("LSDialog_GetIt"),function(){wallify.externalHTTP();});document.getElementById("modal-dialog").style.opacity="1";}else{if(wallify.isActive()){wallify.deactivate();}else{wallify.activate();}};},false);f.addEventListener("click",function(){wallify.externalHTTP();},false);g.innerHTML="v"+wallify.version;g.addEventListener("click",function(){wallify.versionQuery(wallify.versionQueryStart,wallify.versionQueryEnd,function(i){if(i!==wallify.version){wallify.dialog(wallify.localize("LSDialog_NewVersion"),"",wallify.localize("LSDialog_NotNow"),null,wallify.localize("LSDialog_GetIt"),function(){wallify.externalHTTP();});document.getElementById("modal-dialog").style.opacity="1";}else{wallify.dialog(wallify.localize("LSDialog_NoUpdate"),"");document.getElementById("modal-dialog").style.opacity="1";}});},false);e.addEventListener("mousedown",function(){wallify.saverIndexOnDown=document.getElementById("screen-saver-list").selectedIndex;},false);e.addEventListener("change",function(){wallify.chooseSaver();},false);d.addEventListener("click",function(){wallify.dialog(wallify.localize("LSDialog_FullFeature"),"",wallify.localize("OK"),null,wallify.localize("LSDialog_GetIt"),function(){wallify.externalHTTP();});document.getElementById("modal-dialog").style.opacity="1";event.stopPropagation();event.preventDefault();},false);c.addEventListener("click",function(){wallify.dialog(wallify.localize("LSDialog_FullFeature"),"",wallify.localize("OK"),null,wallify.localize("LSDialog_GetIt"),function(){wallify.externalHTTP();});document.getElementById("modal-dialog").style.opacity="1";event.stopPropagation();event.preventDefault();},false);if(wallify.isInDashboard){widget.onshow=function(){if(wallify.isActive()){document.getElementById("front").style.backgroundPositionX="-196px";}else{document.getElementById("front").style.backgroundPositionX="0";}};widget.onremove=function(){var i="";i+="/usr/bin/killall -v ScreenSaverEngine";i+="; ";i+="/bin/rm -f ~/Library/LaunchAgents/widget-"+wallify.bundleId+".plist";if(wallify.isInDashboard){widget.system(i,function(){});}wallify.setPref(wallify.keySaverName,null);wallify.setPref(wallify.keyPreviousQuery,null);wallify.setPref(wallify.keyAutoVersionCheck,null);wallify.setPref(wallify.keyOnAtLogin,null);};widget.ondragstart=function(){document.getElementById("front").style.backgroundPositionY="0";};widget.ondragend=function(){document.getElementById("front").style.backgroundPositionY="-75px";};}wallify.populateScreenSaverList();wallify.loadSavedPrefs();wallify.versionControl();};(function(){window.addEventListener("load",wallify.main,false);}());
